searchNodes=[{"doc":"Oban is a robust job processing library which uses PostgreSQL or SQLite3 for storage and coordination. Installation See the installation guide for details on installing and configuring Oban in your application. Requirements Oban requires Elixir 1.12+, Erlang 22+, and PostgreSQL 12.0+ or SQLite3 3.37.0+. Testing Find testing setup, helpers, and strategies in the testing guide . Oban Web+Pro A web dashboard for managing Oban, along with an official set of extensions, plugins, and workers are available as licensed packages: 🧭 Web Overview 🌟 Pro Overview Learn more about prices and licensing Oban Web+Pro at getoban.pro . Running with SQLite3 Oban ships with engines for PostgreSQL and SQLite3. Both engines support the same core functionality for a single node, while the Postgres engine is more advanced and designed to run in a distributed environment. Running with SQLite3 requires adding ecto_sqlite3 to your app's dependencies and setting the Oban.Engines.Lite engine: config :my_app , Oban , engine : Oban.Engines.Lite , queues : [ default : 10 ] , repo : MyApp.Repo Please note that SQLite3 may not be suitable for high-concurrency systems or for systems that need to handle large amounts of data. If you expect your background jobs to generate high loads, it would be better to use a more robust database solution that supports horizontal scalability, like Postgres. Configuring Queues Queues are specified as a keyword list where the key is the name of the queue and the value is the maximum number of concurrent jobs. The following configuration would start four queues with concurrency ranging from 5 to 50: config :my_app , Oban , queues : [ default : 10 , mailers : 20 , events : 50 , media : 5 ] , repo : MyApp.Repo You may also use an expanded form to configure queues with individual overrides: queues : [ default : 10 , events : [ limit : 50 , paused : true ] ] The events queue will now start in a paused state, which means it won't process anything until Oban.resume_queue/2 is called to start it. There isn't a limit to the number of queues or how many jobs may execute concurrently in each queue. Some additional guidelines: Caveats &amp; Guidelines Each queue will run as many jobs as possible concurrently, up to the configured limit. Make sure your system has enough resources (i.e. database connections) to handle the concurrent load. Queue limits are local (per-node), not global (per-cluster). For example, running a queue with a local limit of one on three separate nodes is effectively a global limit of three. If you require a global limit you must restrict the number of nodes running a particular queue. Only jobs in the configured queues will execute. Jobs in any other queue will stay in the database untouched. Be careful how many concurrent jobs make expensive system calls (i.e. FFMpeg, ImageMagick). The BEAM ensures that the system stays responsive under load, but those guarantees don't apply when using ports or shelling out commands. Defining Workers Worker modules do the work of processing a job. At a minimum they must define a perform/1 function, which is called with an %Oban.Job{} struct. Note that the args field of the job struct will always have string keys, regardless of the key type when the job was enqueued. The args are stored as json and the serialization process automatically stringifies all keys. Define a worker to process jobs in the events queue: defmodule MyApp.Business do use Oban.Worker , queue : :events @impl Oban.Worker def perform ( % Oban.Job { args : %{ &quot;id&quot; =&gt; id } = args } ) do model = MyApp.Repo . get ( MyApp.Business.Man , id ) case args do %{ &quot;in_the&quot; =&gt; &quot;business&quot; } -&gt; IO . inspect ( model ) %{ &quot;vote_for&quot; =&gt; vote } -&gt; IO . inspect ( [ vote , model ] ) _ -&gt; IO . inspect ( model ) end :ok end end The use macro also accepts options to customize max attempts, priority, tags, and uniqueness: defmodule MyApp.LazyBusiness do use Oban.Worker , queue : :events , priority : 3 , max_attempts : 3 , tags : [ &quot;business&quot; ] , unique : [ period : 30 ] @impl Oban.Worker def perform ( _job ) do # do business slowly :ok end end Successful jobs should return :ok or an {:ok, value} tuple. The value returned from perform/1 is used to control whether the job is treated as a success, a failure, cancelled or deferred for retrying later. See the Oban.Worker docs for more details on failure conditions and Oban.Telemetry for details on job reporting. Enqueueing Jobs Jobs are simply Ecto structs and are enqueued by inserting them into the database. For convenience and consistency all workers provide a new/2 function that converts an args map into a job changeset suitable for insertion: %{ id : 1 , in_the : &quot;business&quot; , of_doing : &quot;business&quot; } |&gt; MyApp.Business . new ( ) |&gt; Oban . insert ( ) The worker's defaults may be overridden by passing options: %{ id : 1 , vote_for : &quot;none of the above&quot; } |&gt; MyApp.Business . new ( queue : :special , max_attempts : 5 ) |&gt; Oban . insert ( ) Unique jobs can be configured in the worker, or when the job is built: %{ email : &quot;brewster@example.com&quot; } |&gt; MyApp.Mailer . new ( unique : [ period : 300 , fields : [ :queue , :worker ] ) |&gt; Oban . insert ( ) Job priority can be specified using an integer from 0 to 3, with 0 being the default and highest priority: %{ id : 1 } |&gt; MyApp.Backfiller . new ( priority : 2 ) |&gt; Oban . insert ( ) Any number of tags can be added to a job dynamically, at the time it is inserted: id = 1 %{ id : id } |&gt; MyApp.OnboardMailer . new ( tags : [ &quot;mailer&quot; , &quot;record- \#{ id } &quot; ] ) |&gt; Oban . insert ( ) Multiple jobs can be inserted in a single transaction: Ecto.Multi . new ( ) |&gt; Oban . insert ( :b_job , MyApp.Business . new ( %{ id : 1 } ) ) |&gt; Oban . insert ( :m_job , MyApp.Mailer . new ( %{ email : &quot;brewser@example.com&quot; } ) ) |&gt; Repo . transaction ( ) Occasionally you may need to insert a job for a worker that exists in another application. In that case you can use Oban.Job.new/2 to build the changeset manually: %{ id : 1 , user_id : 2 } |&gt; Oban.Job . new ( queue : :default , worker : OtherApp.Worker ) |&gt; Oban . insert ( ) Oban.insert/2,4 is the preferred way of inserting jobs as it provides some of Oban's advanced features (i.e., unique jobs). However, you can use your application's Repo.insert/2 function if necessary. See Oban.Job.new/2 for a full list of job options. Scheduling Jobs Jobs may be scheduled down to the second any time in the future: %{ id : 1 } |&gt; MyApp.Business . new ( schedule_in : 5 ) |&gt; Oban . insert ( ) Jobs may also be scheduled at a specific datetime in the future: %{ id : 1 } |&gt; MyApp.Business . new ( scheduled_at : ~U[2020-12-25 19:00:56.0Z] ) |&gt; Oban . insert ( ) Scheduling is always in UTC. You'll have to shift timestamps in other zones to UTC before scheduling: %{ id : 1 } |&gt; MyApp.Business . new ( scheduled_at : DateTime . shift_zone! ( datetime , &quot;Etc/UTC&quot; ) ) |&gt; Oban . insert ( ) Caveats &amp; Guidelines Usually, scheduled job management operates in global mode and notifies queues of available jobs via PubSub to minimize database load. However, when PubSub isn't available, staging switches to a local mode where each queue polls independently. Local mode is less efficient and will only happen if you're running in an environment where neither Postgres nor PG notifications work. That situation should be rare and limited to the following conditions: Running with a connection pooler, i.e., pg_bouncer , in transaction mode. Running without clustering, i.e., without Distributed Erlang If both of those criteria apply and PubSub notifications won't work, then staging will switch to polling in local mode. Prioritizing Jobs Normally, all available jobs within a queue are executed in the order they were scheduled. You can override the normal behavior and prioritize or de-prioritize a job by assigning a numerical priority . Priorities from 0-3 are allowed, where 0 is the highest priority and 3 is the lowest. The default priority is 0, unless specified all jobs have an equally high priority. All jobs with a higher priority will execute before any jobs with a lower priority. Within a particular priority jobs are executed in their scheduled order. Unique Jobs The unique jobs feature lets you specify constraints to prevent enqueueing duplicate jobs. Uniqueness is based on a combination of args , queue , worker , state and insertion time. It is configured at the worker or job level using the following options: :period — The number of seconds until a job is no longer considered duplicate. You should always specify a period, otherwise Oban will default to 60 seconds. :infinity can be used to indicate the job be considered a duplicate as long as jobs are retained. :fields — The fields to compare when evaluating uniqueness. The available fields are :args , :queue and :worker , by default all three are used. :keys — A specific subset of the :args to consider when comparing against historic jobs. This allows a job with multiple key/value pairs in the args to be compared using only a subset of them. :states — The job states that are checked for duplicates. The available states are :available , :scheduled , :executing , :retryable , :completed , :cancelled and :discarded . By default all states except for :discarded and :cancelled are checked, which prevents duplicates even if the previous job has been completed. For example, configure a worker to be unique across all fields and states for 60 seconds: use Oban.Worker , unique : [ period : 60 ] Configure the worker to be unique only by :worker and :queue : use Oban.Worker , unique : [ fields : [ :queue , :worker ] , period : 60 ] Or, configure a worker to be unique until it has executed: use Oban.Worker , unique : [ period : 300 , states : [ :available , :scheduled , :executing ] ] Only consider the :url key rather than the entire args : use Oban.Worker , unique : [ fields : [ :args , :worker ] , keys : [ :url ] ] You can use Oban.Job.states/0 to specify uniqueness across all states, including :discarded : use Oban.Worker , unique : [ period : 300 , states : Oban.Job . states ( ) ] Detecting Unique Conflicts When unique settings match an existing job, the return value of Oban.insert/2 is still {:ok, job} . However, you can detect a unique conflict by checking the jobs' :conflict? field. If there was an existing job, the field is true ; otherwise it is false . You can use the :conflict? field to customize responses after insert: with { :ok , % Job { conflict? : true } } &lt;- Oban . insert ( changeset ) do { :error , :job_already_exists } end Note that conflicts are only detected for jobs enqueued through Oban.insert/2,3 . Jobs enqueued through Oban.insert_all/2 do not use per-job unique configuration. Replacing Values In addition to detecting unique conflicts, passing options to replace can update any job field when there is a conflict. Any of the following fields can be replaced per state : args , max_attempts , meta , priority , queue , scheduled_at , tags , worker . For example, to change the priority and increase max_attempts when there is a conflict with a job in a scheduled state: BusinessWorker . new ( args , max_attempts : 5 , priority : 0 , replace : [ scheduled : [ :max_attempts , :priority ] ] ) Another example is bumping the scheduled time on conflict. Either scheduled_at or schedule_in values will work, but the replace option is always scheduled_at . UrgentWorker . new ( args , schedule_in : 1 , replace : [ scheduled : [ :scheduled_at ] ] ) NOTE: If you use this feature to replace a field (e.g. args ) in the executing state by doing something like: UniqueWorker.new(new_args, replace: [executing: [:args]]) Oban will update the args , but the job will continue executing with the original value. Strong Guarantees Unique jobs are guaranteed through transactional locks and database queries: they do not rely on unique constraints in the database. This makes uniqueness entirely configurable by application code, without the need for database migrations. Pruning Historic Jobs Job stats and queue introspection are built on keeping job rows in the database after they have completed. This allows administrators to review completed jobs and build informative aggregates, at the expense of storage and an unbounded table size. To prevent the oban_jobs table from growing indefinitely, Oban provides active pruning of completed , cancelled and discarded jobs. By default, the Pruner plugin retains jobs for 60 seconds. You can configure a longer retention period by providing a max_age in seconds to the Pruner plugin. # Set the max_age for 5 minutes config :my_app , Oban , plugins : [ { Oban.Plugins.Pruner , max_age : 300 } ] ... Caveats &amp; Guidelines Pruning is best-effort and performed out-of-band. This means that all limits are soft; jobs beyond a specified age may not be pruned immediately after jobs complete. Pruning is only applied to jobs that are completed , cancelled or discarded . It'll never delete a new job, a scheduled job or a job that failed and will be retried. Periodic Jobs Oban's Cron plugin registers workers a cron-like schedule and enqueues jobs automatically. Periodic jobs are declared as a list of {cron, worker} or {cron, worker, options} tuples: config :my_app , Oban , repo : MyApp.Repo , plugins : [ { Oban.Plugins.Cron , crontab : [ { &quot;* * * * *&quot; , MyApp.MinuteWorker } , { &quot;0 * * * *&quot; , MyApp.HourlyWorker , args : %{ custom : &quot;arg&quot; } } , { &quot;0 0 * * *&quot; , MyApp.DailyWorker , max_attempts : 1 } , { &quot;0 12 * * MON&quot; , MyApp.MondayWorker , queue : :scheduled , tags : [ &quot;mondays&quot; ] } , { &quot;@daily&quot; , MyApp.AnotherDailyWorker } ] } ] The crontab would insert jobs as follows: MyApp.MinuteWorker — Inserted once every minute MyApp.HourlyWorker — Inserted at the first minute of every hour with custom args MyApp.DailyWorker — Inserted at midnight every day with no retries MyApp.MondayWorker — Inserted at noon every Monday in the &quot;scheduled&quot; queue MyApp.AnotherDailyWorker — Inserted at midnight every day with no retries The crontab format respects all standard rules and has one minute resolution. Jobs are considered unique for most of each minute, which prevents duplicate jobs with multiple nodes and across node restarts. Like other jobs, recurring jobs will use the :queue specified by the worker module (or :default if one is not specified). Cron Expressions Standard Cron expressions are composed of rules specifying the minutes, hours, days, months and weekdays. Rules for each field are comprised of literal values, wildcards, step values or ranges: * — Wildcard, matches any value (0, 1, 2, ...) 0 — Literal, matches only itself (only 0) */15 — Step, matches any value that is a multiple (0, 15, 30, 45) 0-5 — Range, matches any value within the range (0, 1, 2, 3, 4, 5) 0-9/2 - Step values can be used in conjunction with ranges (0, 2, 4, 6, 8) Each part may have multiple rules, where rules are separated by a comma. The allowed values for each field are as follows: minute — 0-59 hour — 0-23 days — 1-31 month — 1-12 (or aliases, JAN , FEB , MAR , etc.) weekdays — 0-6 (or aliases, SUN , MON , TUE , etc.) The following Cron extensions are supported: @hourly — 0 * * * * @daily (as well as @midnight ) — 0 0 * * * @weekly — 0 0 * * 0 @monthly — 0 0 1 * * @yearly (as well as @annually ) — 0 0 1 1 * @reboot — Run once at boot across the entire cluster Some specific examples that demonstrate the full range of expressions: 0 * * * * — The first minute of every hour */15 9-17 * * * — Every fifteen minutes during standard business hours 0 0 * DEC * — Once a day at midnight during December 0 7-9,4-6 13 * FRI — Once an hour during both rush hours on Friday the 13th For more in depth information see the man documentation for cron and crontab in your system. Alternatively you can experiment with various expressions online at Crontab Guru . Caveats &amp; Guidelines All schedules are evaluated as UTC unless a different timezone is provided. See Oban.Plugins.Cron for information about configuring a timezone. Workers can be used for regular and scheduled jobs so long as they accept different arguments. Duplicate jobs are prevented through transactional locks and unique constraints. Workers that are used for regular and scheduled jobs must not specify unique options less than 60s . Long running jobs may execute simultaneously if the scheduling interval is shorter than it takes to execute the job. You can prevent overlap by passing custom unique opts in the crontab config: custom_args = %{ scheduled : true } unique_opts = [ period : 60 * 60 * 24 , states : [ :available , :scheduled , :executing ] ] config :my_app , Oban , repo : MyApp.Repo , plugins : [ { Oban.Plugins.Cron , crontab : [ { &quot;* * * * *&quot; , MyApp.SlowWorker , args : custom_args , unique : unique_opts } ] } ] Error Handling When a job returns an error value, raises an error, or exits during execution the details are recorded within the errors array on the job. When the number of execution attempts is below the configured max_attempts limit, the job will automatically be retried in the future. The retry delay has an exponential backoff, meaning the job's second attempt will be after 16s, third after 31s, fourth after 1m 36s, etc. See the Oban.Worker documentation on &quot;Customizing Backoff&quot; for alternative backoff strategies. Error Details Execution errors are stored as a formatted exception along with metadata about when the failure occurred and which attempt caused it. Each error is stored with the following keys: at The UTC timestamp when the error occurred at attempt The attempt number when the error occurred error A formatted error message and stacktrace See the Instrumentation docs for an example of integrating with external error reporting systems. Limiting Retries By default, jobs are retried up to 20 times. The number of retries is controlled by the max_attempts value, which can be set at the Worker or Job level. For example, to instruct a worker to discard jobs after three failures: use Oban.Worker , queue : :limited , max_attempts : 3 Limiting Execution Time By default, individual jobs may execute indefinitely. If this is undesirable you may define a timeout in milliseconds with the timeout/1 callback on your worker module. For example, to limit a worker's execution time to 30 seconds: def MyApp.Worker do use Oban.Worker @impl Oban.Worker def perform ( _job ) do something_that_may_take_a_long_time ( ) :ok end @impl Oban.Worker def timeout ( _job ) , do : :timer . seconds ( 30 ) end The timeout/1 function accepts an Oban.Job struct, so you can customize the timeout using any job attributes. Define the timeout value through job args: def timeout ( % _ { args : %{ &quot;timeout&quot; =&gt; timeout } } ) , do : timeout Define the timeout based on the number of attempts: def timeout ( % _ { attempt : attempt } ) , do : attempt * :timer . seconds ( 5 ) Instrumentation, Error Reporting, and Logging Oban provides integration with Telemetry , a dispatching library for metrics. It is easy to report Oban metrics to any backend by attaching to :oban events. Here is an example of a sample unstructured log handler: defmodule MyApp.ObanLogger do require Logger def handle_event ( [ :oban , :job , :start ] , measure , meta , _ ) do Logger . warn ( &quot;[Oban] :started \#{ meta . worker } at \#{ measure . system_time } &quot; ) end def handle_event ( [ :oban , :job , event ] , measure , meta , _ ) do Logger . warn ( &quot;[Oban] \#{ event } \#{ meta . worker } ran in \#{ measure . duration } &quot; ) end end Attach the handler to success and failure events in application.ex : events = [ [ :oban , :job , :start ] , [ :oban , :job , :stop ] , [ :oban , :job , :exception ] ] :telemetry . attach_many ( &quot;oban-logger&quot; , events , &amp; MyApp.ObanLogger . handle_event / 4 , [ ] ) The Oban.Telemetry module provides a robust structured logger that handles all of Oban's telemetry events. As in the example above, attach it within your application.ex module: :ok = Oban.Telemetry . attach_default_logger ( ) For more details on the default structured logger and information on event metadata see docs for the Oban.Telemetry module. Reporting Errors Another great use of execution data is error reporting. Here is an example of integrating with Sentry to report job failures: defmodule ErrorReporter do def handle_event ( [ :oban , :job , :exception ] , measure , meta , _ ) do extra = meta . job |&gt; Map . take ( [ :id , :args , :meta , :queue , :worker ] ) |&gt; Map . merge ( measure ) Sentry . capture_exception ( meta . reason , stacktrace : meta . stacktrace , extra : extra ) end end :telemetry . attach ( &quot;oban-errors&quot; , [ :oban , :job , :exception ] , &amp; ErrorReporter . handle_event / 4 , [ ] ) You can use exception events to send error reports to Honeybadger, Rollbar, AppSignal or any other application monitoring platform. Instance and Database Isolation You can run multiple Oban instances with different prefixes on the same system and have them entirely isolated, provided you give each supervisor a distinct id. Here we configure our application to start three Oban supervisors using the &quot;public&quot;, &quot;special&quot; and &quot;private&quot; prefixes, respectively: def start ( _type , _args ) do children = [ Repo , Endpoint , { Oban , name : ObanA , repo : Repo } , { Oban , name : ObanB , repo : Repo , prefix : &quot;special&quot; } , { Oban , name : ObanC , repo : Repo , prefix : &quot;private&quot; } ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end Umbrella Apps If you need to run Oban from an umbrella application where more than one of the child apps need to interact with Oban, you may need to set the :name for each child application that configures Oban. For example, your umbrella contains two apps: MyAppA and MyAppB . MyAppA is responsible for inserting jobs, while only MyAppB actually runs any queues. Configure Oban with a custom name for MyAppA : config :my_app_a , Oban , name : MyAppA.Oban , repo : MyApp.Repo Then configure Oban for MyAppB with a different name: config :my_app_b , Oban , name : MyAppB.Oban , repo : MyApp.Repo , queues : [ default : 10 ] Now, use the configured name when calling functions like Oban.insert/2 , Oban.insert_all/2 , Oban.drain_queue/2 , etc., to reference the correct Oban process for the current application. Oban . insert ( MyAppA.Oban , MyWorker . new ( %{ } ) ) Oban . insert_all ( MyAppB.Oban , multi , :multiname , [ MyWorker . new ( %{ } ) ] ) Oban . drain_queue ( MyAppB.Oban , queue : :default ) Database Prefixes Oban supports namespacing through PostgreSQL schemas, also called &quot;prefixes&quot; in Ecto. With prefixes your jobs table can reside outside of your primary schema (usually public) and you can have multiple separate job tables. To use a prefix you first have to specify it within your migration: defmodule MyApp.Repo.Migrations.AddPrefixedObanJobsTable do use Ecto.Migration def up do Oban.Migrations . up ( prefix : &quot;private&quot; ) end def down do Oban.Migrations . down ( prefix : &quot;private&quot; ) end end The migration will create the &quot;private&quot; schema and all tables, functions and triggers within that schema. With the database migrated you'll then specify the prefix in your configuration: config :my_app , Oban , prefix : &quot;private&quot; , repo : MyApp.Repo , queues : [ default : 10 ] Now all jobs are inserted and executed using the private.oban_jobs table. Note that Oban.insert/2,4 will write jobs in the private.oban_jobs table, you'll need to specify a prefix manually if you insert jobs directly through a repo. Not only is the oban_jobs table isolated within the schema, but all notification events are also isolated. That means that insert/update events will only dispatch new jobs for their prefix. Dynamic Repositories Oban supports Ecto dynamic repositories through the :get_dynamic_repo option. To make this work, you need to run a separate Oban instance per each dynamic repo instance. Most often it's worth bundling each Oban and repo instance under the same supervisor: def start_repo_and_oban ( instance_id ) do children = [ { MyDynamicRepo , name : nil , url : repo_url ( instance_id ) } , { Oban , name : instance_id , get_dynamic_repo : fn -&gt; repo_pid ( instance_id ) end } ] Supervisor . start_link ( children , strategy : :one_for_one ) end The function repo_pid/1 must return the pid of the repo for the given instance. You can use Registry to register the repo (for example in the repo's init/2 callback) and discover it. If your application exclusively uses dynamic repositories and doesn't specify all credentials upfront, you must implement an init/1 callback in your Ecto Repo. Doing so provides the Postgres notifier with the correct credentials on init, allowing jobs to process as expected.","ref":"Oban.html","title":"Oban","type":"module"},{"doc":"Cancel many jobs based on a queryable and mark them as cancelled to prevent them from running. Any currently executing jobs are killed while the others are ignored. If executing jobs happen to fail before cancellation then the state is set to cancelled . However, any that complete successfully will remain completed . Only jobs with the statuses executing , available , scheduled , or retryable can be cancelled. Example Cancel all jobs: Oban . cancel_all_jobs ( Oban.Job ) { :ok , 9 } Cancel all jobs for a specific worker: Oban.Job |&gt; Ecto.Query . where ( worker : &quot;MyApp.MyWorker&quot; ) |&gt; Oban . cancel_all_jobs ( ) { :ok , 2 }","ref":"Oban.html#cancel_all_jobs/2","title":"Oban.cancel_all_jobs/2","type":"function"},{"doc":"Cancel an executing , available , scheduled or retryable job and mark it as cancelled to prevent it from running. If the job is currently executing it will be killed and otherwise it is ignored. If an executing job happens to fail before it can be cancelled the state is set to cancelled . However, if it manages to complete successfully then the state will still be completed . Example Cancel a job: Oban . cancel_job ( job ) :ok","ref":"Oban.html#cancel_job/2","title":"Oban.cancel_job/2","type":"function"},{"doc":"Check the current state of a queue producer. This allows you to introspect on a queue's health by retrieving key attributes of the producer's state; values such as the current limit , the running job ids, and when the producer was started. Options :queue - a string or atom specifying the queue to check, required Example Oban . check_queue ( queue : :default ) %{ limit : 10 , node : &quot;me@local&quot; , paused : false , queue : &quot;default&quot; , running : [ 100 , 102 ] , started_at : ~D[2020-10-07 15:31:00] , updated_at : ~D[2020-10-07 15:31:00] }","ref":"Oban.html#check_queue/2","title":"Oban.check_queue/2","type":"function"},{"doc":"Retrieve the Oban.Config struct for a named Oban supervision tree. Example Retrieve the default Oban instance config: % Oban.Config { } = Oban . config ( ) Retrieve the config for an instance started with a custom name: % Oban.Config { } = Oban . config ( MyCustomOban )","ref":"Oban.html#config/1","title":"Oban.config/1","type":"function"},{"doc":"Synchronously execute all available jobs in a queue. All execution happens within the current process and it is guaranteed not to raise an error or exit. Draining a queue from within the current process is especially useful for testing. Jobs that are enqueued by a process when Ecto is in sandbox mode are only visible to that process. Calling drain_queue/2 allows you to control when the jobs are executed and to wait synchronously for all jobs to complete. Failures &amp; Retries Draining a queue uses the same execution mechanism as regular job dispatch. That means that any job failures or crashes are captured and result in a retry. Retries are scheduled in the future with backoff and won't be retried immediately. By default jobs are executed in safe mode, just as they are in production. Safe mode catches any errors or exits and records the formatted error in the job's errors array. That means exceptions and crashes are not bubbled up to the calling process. If you expect jobs to fail, would like to track failures, or need to check for specific errors you can pass the with_safety: false flag. See the &quot;Options&quot; section below for more details. Scheduled Jobs By default, drain_queue/2 will execute all currently available jobs. In order to execute scheduled jobs, you may pass the with_scheduled: true which will cause all scheduled jobs to be marked as available beforehand. To run jobs scheduled up to a specific point in time, pass a DateTime instead. Options :queue - a string or atom specifying the queue to drain, required :with_limit — the maximum number of jobs to drain at once. When recursion is enabled this is how many jobs are processed per-iteration. :with_recursion — whether to keep draining a queue repeatedly when jobs insert more jobs :with_safety — whether to silently catch errors when draining, defaults to true . When false , raised exceptions or unhandled exits are reraised (unhandled exits are wrapped in Oban.CrashError ). :with_scheduled — whether to include any scheduled jobs when draining, default false . When true , drains all scheduled jobs. When a DateTime is provided, drains all jobs scheduled up to, and including, that point in time. Example Drain a queue with three available jobs, two of which succeed and one of which fails: Oban . drain_queue ( queue : :default ) %{ failure : 1 , snoozed : 0 , success : 2 } Drain a queue including any scheduled jobs: Oban . drain_queue ( queue : :default , with_scheduled : true ) %{ failure : 0 , snoozed : 0 , success : 1 } Drain a queue including jobs scheduled up to a minute: Oban . drain_queue ( queue : :default , with_scheduled : DateTime . add ( DateTime . utc_now ( ) , 60 , :second ) ) Drain a queue and assert an error is raised: assert_raise RuntimeError , fn -&gt; Oban . drain_queue ( queue : :risky , with_safety : false ) end Drain a queue repeatedly until there aren't any more jobs to run. This is particularly useful for testing jobs that enqueue other jobs: Oban . drain_queue ( queue : :default , with_recursion : true ) %{ failure : 1 , snoozed : 0 , success : 2 } Drain only the top (by scheduled time and priority) five jobs off a queue: Oban . drain_queue ( queue : :default , with_limit : 5 ) %{ failure : 0 , snoozed : 0 , success : 1 } Drain a queue recursively, only one job at a time: Oban . drain_queue ( queue : :default , with_limit : 1 , with_recursion : true ) %{ failure : 0 , snoozed : 0 , success : 3 }","ref":"Oban.html#drain_queue/2","title":"Oban.drain_queue/2","type":"function"},{"doc":"Insert a new job into the database for execution. This and the other insert variants are the recommended way to enqueue jobs because they support features like unique jobs. See the section on &quot;Unique Jobs&quot; for more details. Example Insert a single job: { :ok , job } = Oban . insert ( MyApp.Worker . new ( %{ id : 1 } ) ) Insert a job while ensuring that it is unique within the past 30 seconds: { :ok , job } = Oban . insert ( MyApp.Worker . new ( %{ id : 1 } , unique : [ period : 30 ] ) ) Insert a job using a custom timeout: { :ok , job } = Oban . insert ( MyApp.Worker . new ( %{ id : 1 } ) , timeout : 10_000 ) Insert a job using an alternative instance name: { :ok , job } = Oban . insert ( MyOban , MyApp.Worker . new ( %{ id : 1 } ) )","ref":"Oban.html#insert/3","title":"Oban.insert/3","type":"function"},{"doc":"Put a job insert operation into an Ecto.Multi . Like insert/2 , this variant is recommended over Ecto.Multi.insert because it supports all of Oban's features, i.e. unique jobs. See the section on &quot;Unique Jobs&quot; for more details. Example Ecto.Multi . new ( ) |&gt; Oban . insert ( &quot;job-1&quot; , MyApp.Worker . new ( %{ id : 1 } ) ) |&gt; Oban . insert ( &quot;job-2&quot; , fn _ -&gt; MyApp.Worker . new ( %{ id : 2 } ) end ) |&gt; MyApp.Repo . transaction ( )","ref":"Oban.html#insert/5","title":"Oban.insert/5","type":"function"},{"doc":"Similar to insert/3 , but raises an Ecto.InvalidChangesetError if the job can't be inserted. Example Insert a single job: job = Oban . insert! ( MyApp.Worker . new ( %{ id : 1 } ) ) Insert a job using a custom timeout: job = Oban . insert! ( MyApp.Worker . new ( %{ id : 1 } ) , timeout : 10_000 ) Insert a job using an alternative instance name: job = Oban . insert! ( MyOban , MyApp.Worker . new ( %{ id : 1 } ) )","ref":"Oban.html#insert!/3","title":"Oban.insert!/3","type":"function"},{"doc":"Insert multiple jobs into the database for execution. There are a few important differences between this function and Ecto.Repo.insert_all/3 : This function always returns a list rather than a tuple of {count, records} This function accepts a list of changesets rather than a list of maps or keyword lists 🌟 Unique Jobs and Batching Only the SmartEngine in Oban Pro supports bulk unique jobs and automatic batching. With the basic engine, you must use insert/3 for unique support. Options Accepts any of Ecto's &quot;Shared Options&quot; such as timeout and log . Example Insert 100 jobs with a single operation: 1 .. 100 |&gt; Enum . map ( &amp; MyApp.Worker . new ( %{ id : &amp;1 } ) ) |&gt; Oban . insert_all ( ) Insert with a custom timeout: 1 .. 100 |&gt; Enum . map ( &amp; MyApp.Worker . new ( %{ id : &amp;1 } ) ) |&gt; Oban . insert_all ( timeout : 10_000 ) Insert with an alternative instance name: changesets = Enum . map ( 1 .. 100 , &amp; MyApp.Worker . new ( %{ id : &amp;1 } ) ) jobs = Oban . insert_all ( MyOban , changesets )","ref":"Oban.html#insert_all/3","title":"Oban.insert_all/3","type":"function"},{"doc":"Put an insert_all operation into an Ecto.Multi . This function supports the same features and has the same caveats as insert_all/2 . Example Insert job changesets within a multi: changesets = Enum . map ( 0 .. 100 , &amp; MyApp.Worker . new ( %{ id : &amp;1 } ) ) Ecto.Multi . new ( ) |&gt; Oban . insert_all ( :jobs , changesets ) |&gt; MyApp.Repo . transaction ( ) Insert job changesets using a function: Ecto.Multi . new ( ) |&gt; Ecto.Multi . insert ( :user , user_changeset ) |&gt; Oban . insert_all ( :jobs , fn %{ user : user } -&gt; email_job = EmailWorker . new ( %{ id : user . id } ) staff_job = StaffWorker . new ( %{ id : user . id } ) [ email_job , staff_job ] end ) |&gt; MyApp.Repo . transaction ( )","ref":"Oban.html#insert_all/5","title":"Oban.insert_all/5","type":"function"},{"doc":"Pause a running queue, preventing it from executing any new jobs. All running jobs will remain running until they are finished. When shutdown begins all queues are paused. Options :queue - a string or atom specifying the queue to pause, required :local_only - whether the queue will be paused only on the local node, default: false :node - restrict pausing to a particular node Note: by default, Oban does not verify that the given queue exists unless :local_only is set to true as even if the queue does not exist locally, it might be running on another node. Example Pause the default queue: Oban . pause_queue ( queue : :default ) :ok Pause the default queue, but only on the local node: Oban . pause_queue ( queue : :default , local_only : true ) :ok Pause the default queue only on a particular node: Oban . pause_queue ( queue : :default , node : &quot;worker.1&quot; ) :ok","ref":"Oban.html#pause_queue/2","title":"Oban.pause_queue/2","type":"function"},{"doc":"Resume executing jobs in a paused queue. Options :queue - a string or atom specifying the queue to resume, required :local_only - whether the queue will be resumed only on the local node, default: false :node - restrict resuming to a particular node Note: by default, Oban does not verify that the given queue exists unless :local_only is set to true as even if the queue does not exist locally, it might be running on another node. Example Resume a paused default queue: Oban . resume_queue ( queue : :default ) :ok Resume the default queue, but only on the local node: Oban . resume_queue ( queue : :default , local_only : true ) :ok Resume the default queue only on a particular node: Oban . resume_queue ( queue : :default , node : &quot;worker.1&quot; ) :ok","ref":"Oban.html#resume_queue/2","title":"Oban.resume_queue/2","type":"function"},{"doc":"Retries all jobs that match on the given queryable. Please note that no matter the queryable constraints, it will never retry available , executing or scheduled jobs. If no queryable is given, Oban will retry all jobs in retryable states. Example Retries all retryable jobs Oban . retry_all_jobs ( Oban.Job ) { :ok , 9 } Retries all retryable jobs with priority 0 Oban.Job |&gt; Ecto.Query . where ( priority : 0 ) |&gt; Oban . retry_all_jobs ( ) { :ok , 5 }","ref":"Oban.html#retry_all_jobs/2","title":"Oban.retry_all_jobs/2","type":"function"},{"doc":"Sets a job as available , adding attempts if already maxed out. Jobs currently available , executing or scheduled are ignored. The job is scheduled for immediate execution. Example Retry a job: Oban . retry_job ( job ) :ok","ref":"Oban.html#retry_job/2","title":"Oban.retry_job/2","type":"function"},{"doc":"Scale the concurrency for a queue. Options :queue - a string or atom specifying the queue to scale, required :limit — the new concurrency limit, required :local_only — whether the queue will be scaled only on the local node, default: false :node - restrict scaling to a particular node In addition, all engine-specific queue options are passed along after validation. Note: by default, Oban does not verify that the given queue exists unless :local_only is set to true as even if the queue does not exist locally, it might be running on another node. Example Scale a queue up, triggering immediate execution of queued jobs: Oban . scale_queue ( queue : :default , limit : 50 ) :ok Scale the queue back down, allowing executing jobs to finish: Oban . scale_queue ( queue : :default , limit : 5 ) :ok Scale the queue only on the local node: Oban . scale_queue ( queue : :default , limit : 10 , local_only : true ) :ok Scale the queue on a particular node: Oban . scale_queue ( queue : :default , limit : 10 , node : &quot;worker.1&quot; ) :ok","ref":"Oban.html#scale_queue/2","title":"Oban.scale_queue/2","type":"function"},{"doc":"Starts an Oban supervision tree linked to the current process. Options These options are required; without them the supervisor won't start: :repo — specifies the Ecto repo used to insert and retrieve jobs Primary Options These options determine what the system does at a high level, i.e. which queues to run: :engine — facilitates inserting, fetching, and otherwise managing jobs. There are three built-in engines: Oban.Engines.Basic for Postgres databases, Oban.Engines.Lite for SQLite3 databases, and Oban.Engines.Inline for simplified testing (only available for :inline testing mode). When the Oban.Engines.Lite engine is used the :notifier and :peer are automatically set to PG and isolated mode, respectively. Additional engines, such as Oban Pro's SmartEngine with advanced functionality for Postgres, are also available as an add-on. Defaults to the Basic engine for Postgres. :log — either false to disable logging or a standard log level ( :error , :warn , :info , :debug ). This determines whether queries are logged or not; overriding the repo's configured log level. Defaults to false , where no queries are logged. :name — used for supervisor registration, it must be unique across an entire VM instance. Defaults to Oban when no name is provided. :node — used to identify the node that the supervision tree is running in. If no value is provided it will use the node name in a distributed system, or the hostname in an isolated node. See &quot;Node Name&quot; below. :notifier — used to relay messages between processes, nodes, and the Postgres database. There are two built-in notifiers: Oban.Notifiers.Postgres , which uses Postgres PubSub; and Oban.Notifiers.PG , which uses process groups with distributed erlang. Defaults to the Postgres notifier. :peer — used to specify which peer module to use for cluster leadership. There are two built-in peers: Oban.Peers.Postgres , which uses table-based leadership through the oban_peers table; and Oban.Peers.Global , which uses global locks through distributed Erlang. Leadership can be disabled by setting peer: false , but note that centralized plugins like Cron won't run without leadership. Defaults to the Postgres peer. :plugins — a list or modules or module/option tuples that are started as children of an Oban supervisor. Any supervisable module is a valid plugin, i.e. a GenServer or an Agent . :prefix — the query prefix, or schema, to use for inserting and executing jobs. An oban_jobs table must exist within the prefix. See the &quot;Prefix Support&quot; section in the module documentation for more details. :queues — a keyword list where the keys are queue names and the values are the concurrency setting or a keyword list of queue options. For example, setting queues to [default: 10, exports: 5] would start the queues default and exports with a combined concurrency level of 15. The concurrency setting specifies how many jobs each queue will run concurrently. Queues accept additional override options to customize their behavior, e.g. by setting paused or dispatch_cooldown for a specific queue. :testing — a mode that controls how an instance is configured for testing. When set to :inline or :manual queues, peers, and plugins are automatically disabled. Defaults to :disabled , no test mode. Twiddly Options Additional options used to tune system behaviour. These are primarily useful for testing or troubleshooting and don't usually need modification. :dispatch_cooldown — the minimum number of milliseconds a producer will wait before fetching and running more jobs. A slight cooldown period prevents a producer from flooding with messages and thrashing the database. The cooldown period directly impacts a producer's throughput: jobs per second for a single queue is calculated by (1000 / cooldown) * limit . For example, with a 5ms cooldown and a queue limit of 25 a single queue can run 5,000 jobs/sec. The default is 5ms and the minimum is 1ms , which is likely faster than the database can return new jobs to run. :shutdown_grace_period — the amount of time a queue will wait for executing jobs to complete before hard shutdown, specified in milliseconds. The default is 15_000 , or 15 seconds. :stage_interval — the number of milliseconds between making scheduled jobs available and notifying relevant queues that jobs are available. This is directly tied to the resolution of scheduled or retryable jobs and how frequently the database is checked for jobs to run. To minimize database load, only 5_000 jobs are staged at each interval. Only the leader node stages jobs and notifies queues when the :notifier's pubsub notifications are functional. If pubusb messages can't get through then staging switches to a less efficient &quot;local&quot; mode in which all nodes poll for jobs to run. Setting the interval to :infinity disables staging entirely. The default is 1_000ms . Example Start a stand-alone Oban instance: { :ok , pid } = Oban . start_link ( repo : MyApp.Repo , queues : [ default : 10 ] ) To start an Oban instance within an application's supervision tree: def start ( _type , _args ) do children = [ MyApp.Repo , { Oban , repo : MyApp.Repo , queues : [ default : 10 ] } ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end Start multiple, named Oban supervisors within a supervision tree: children = [ MyApp.Repo , { Oban , name : Oban.A , repo : MyApp.Repo , queues : [ default : 10 ] } , { Oban , name : Oban.B , repo : MyApp.Repo , queues : [ special : 10 ] } , ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) Start a local Oban instance for SQLite: { :ok , pid } = Oban . start_link ( engine : Oban.Engines.Lite , repo : MyApp.Repo ) Node Name When the node value hasn't been configured it is generated based on the environment: In a distributed system the node name is used In a Heroku environment the system environment's DYNO value is used Otherwise, the system hostname is used","ref":"Oban.html#start_link/1","title":"Oban.start_link/1","type":"function"},{"doc":"Start a new supervised queue. By default this starts a new supervised queue across all nodes running Oban on the same database and prefix. You can pass the option local_only: true if you prefer to start the queue only on the local node. Options :queue - a string or atom specifying the queue to start, required :local_only - whether the queue will be started only on the local node, default: false :limit - set the concurrency limit, required :paused — set whether the queue starts in the &quot;paused&quot; state, optional In addition, all engine-specific queue options are passed along after validation. Example Start the :priority queue with a concurrency limit of 10 across the connected nodes. Oban . start_queue ( queue : :priority , limit : 10 ) :ok Start the :media queue with a concurrency limit of 5 only on the local node. Oban . start_queue ( queue : :media , limit : 5 , local_only : true ) :ok Start the :media queue on a particular node. Oban . start_queue ( queue : :media , limit : 5 , node : &quot;worker.1&quot; ) :ok Start the :media queue in a paused state. Oban . start_queue ( queue : :media , limit : 5 , paused : true ) :ok","ref":"Oban.html#start_queue/2","title":"Oban.start_queue/2","type":"function"},{"doc":"Shutdown a queue's supervision tree and stop running jobs for that queue. By default this action will occur across all the running nodes. Still, if you prefer to stop the queue's supervision tree and stop running jobs for that queue only on the local node, you can pass the option: local_only: true The shutdown process pauses the queue first and allows current jobs to exit gracefully, provided they finish within the shutdown limit. Note: by default, Oban does not verify that the given queue exists unless :local_only is set to true as even if the queue does not exist locally, it might be running on another node. Options :queue - a string or atom specifying the queue to stop, required :local_only - whether the queue will be stopped only on the local node, default: false :node - restrict stopping to a particular node Example Stop a running queue on all nodes: Oban . stop_queue ( queue : :default ) :ok Stop the queue only on the local node: Oban . stop_queue ( queue : :media , local_only : true ) :ok Stop the queue only on a particular node: Oban . stop_queue ( queue : :media , node : &quot;worker.1&quot; ) :ok","ref":"Oban.html#stop_queue/2","title":"Oban.stop_queue/2","type":"function"},{"doc":"Returns the pid of the root Oban process for the given name. Example Find the default instance: Oban . whereis ( Oban ) Find a dynamically named instance: Oban . whereis ( { :oban , 1 } )","ref":"Oban.html#whereis/1","title":"Oban.whereis/1","type":"function"},{"doc":"","ref":"Oban.html#t:changeset_or_fun/0","title":"Oban.changeset_or_fun/0","type":"type"},{"doc":"","ref":"Oban.html#t:changeset_wrapper/0","title":"Oban.changeset_wrapper/0","type":"type"},{"doc":"","ref":"Oban.html#t:changesets_or_wrapper/0","title":"Oban.changesets_or_wrapper/0","type":"type"},{"doc":"","ref":"Oban.html#t:changesets_or_wrapper_or_fun/0","title":"Oban.changesets_or_wrapper_or_fun/0","type":"type"},{"doc":"","ref":"Oban.html#t:drain_option/0","title":"Oban.drain_option/0","type":"type"},{"doc":"","ref":"Oban.html#t:drain_result/0","title":"Oban.drain_result/0","type":"type"},{"doc":"","ref":"Oban.html#t:multi/0","title":"Oban.multi/0","type":"type"},{"doc":"","ref":"Oban.html#t:multi_name/0","title":"Oban.multi_name/0","type":"type"},{"doc":"","ref":"Oban.html#t:name/0","title":"Oban.name/0","type":"type"},{"doc":"","ref":"Oban.html#t:option/0","title":"Oban.option/0","type":"type"},{"doc":"","ref":"Oban.html#t:queue_name/0","title":"Oban.queue_name/0","type":"type"},{"doc":"","ref":"Oban.html#t:queue_option/0","title":"Oban.queue_option/0","type":"type"},{"doc":"","ref":"Oban.html#t:queue_state/0","title":"Oban.queue_state/0","type":"type"},{"doc":"A Job is an Ecto schema used for asynchronous execution. Job changesets are created by your application code and inserted into the database for asynchronous execution. Jobs can be inserted along with other application data as part of a transaction, which guarantees that jobs will only be triggered from a successful transaction.","ref":"Oban.Job.html","title":"Oban.Job","type":"module"},{"doc":"Normalize, blame, and format a job's unsaved_error into the stored error format. Formatted errors are stored in a job's errors field.","ref":"Oban.Job.html#format_attempt/1","title":"Oban.Job.format_attempt/1","type":"function"},{"doc":"Construct a new job changeset ready for insertion into the database. Options :max_attempts — the maximum number of times a job can be retried if there are errors during execution :meta — a map containing additional information about the job :priority — a numerical indicator from 0 to 3 of how important this job is relative to other jobs in the same queue. The lower the number, the higher priority the job. :queue — a named queue to push the job into. Jobs may be pushed into any queue, regardless of whether jobs are currently being processed for the queue. :replace - a list of keys to replace per state on a unique conflict :scheduled_at - a time in the future after which the job should be executed :schedule_in - the number of seconds until the job should be executed or a tuple containing a number and unit :tags — a list of tags to group and organize related jobs, i.e. to identify scheduled jobs :unique — a keyword list of options specifying how uniqueness will be calculated. The options define which fields will be used, for how long, with which keys, and for which states. :worker — a module to execute the job in. The module must implement the Oban.Worker behaviour. Examples Insert a job with the :default queue: %{ id : 1 , user_id : 2 } |&gt; Oban.Job . new ( queue : :default , worker : MyApp.Worker ) |&gt; Oban . insert ( ) Generate a pre-configured job for MyApp.Worker and push it: %{ id : 1 , user_id : 2 } |&gt; MyApp.Worker . new ( ) |&gt; Oban . insert ( ) Schedule a job to run in 5 seconds: %{ id : 1 } |&gt; MyApp.Worker . new ( schedule_in : 5 ) |&gt; Oban . insert ( ) Schedule a job to run in 5 minutes: %{ id : 1 } |&gt; MyApp.Worker . new ( schedule_in : { 5 , :minutes } ) |&gt; Oban . insert ( ) Insert a job, ensuring that it is unique within the past minute: %{ id : 1 } |&gt; MyApp.Worker . new ( unique : [ period : 60 ] ) |&gt; Oban . insert ( ) Insert a unique job based only on the worker field, and within multiple states: fields = [ :worker ] states = [ :available , :scheduled , :executing , :retryable , :completed ] %{ id : 1 } |&gt; MyApp.Worker . new ( unique : [ fields : fields , period : 60 , states : states ] ) |&gt; Oban . insert ( ) Insert a unique job considering only the worker and specified keys in the args: keys = [ :account_id , :url ] %{ account_id : 1 , url : &quot;https://example.com&quot; } |&gt; MyApp.Worker . new ( unique : [ fields : [ :args , :worker ] , keys : keys ] ) |&gt; Oban . insert ( ) Insert a unique job considering only specified keys in the meta: unique = [ fields : [ :meta ] , keys : [ :slug ] ] %{ id : 1 } |&gt; MyApp.Worker . new ( meta : %{ slug : &quot;unique-key&quot; } , unique : unique ) |&gt; Oban . insert ( )","ref":"Oban.Job.html#new/2","title":"Oban.Job.new/2","type":"function"},{"doc":"A canonical list of all possible job states. This may be used to build up :unique options without duplicating states in application code. Examples iex&gt; Oban.Job . states ( ) -- [ :completed , :discarded ] [ :scheduled , :available , :executing , :retryable , :cancelled ] Job State Transitions :scheduled —Jobs inserted with scheduled_at in the future are :scheduled . After the scheduled_at time has ellapsed the Oban.Plugins.Stager will transition them to :available :available —Jobs without a future scheduled_at timestamp are inserted as :available and may execute immediately :executing —Available jobs may be ran, at which point they are :executing :retryable —Jobs that fail and haven't exceeded their max attempts are transitiond to :retryable and rescheduled until after a backoff period. Once the backoff has ellapsed the Oban.Plugins.Stager will transition them back to :available :completed —Jobs that finish executing succesfully are marked :completed :discarded —Jobs that fail and exhaust their max attempts, or return a :discard tuple during execution, are marked :discarded :cancelled —Jobs that are cancelled intentionally","ref":"Oban.Job.html#states/0","title":"Oban.Job.states/0","type":"function"},{"doc":"Convert a Job changeset into a map suitable for database insertion. Examples Convert a worker generated changeset into a plain map: %{ id : 123 } |&gt; MyApp.Worker . new ( ) |&gt; Oban.Job . to_map ( )","ref":"Oban.Job.html#to_map/1","title":"Oban.Job.to_map/1","type":"function"},{"doc":"","ref":"Oban.Job.html#t:args/0","title":"Oban.Job.args/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:changeset/0","title":"Oban.Job.changeset/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:changeset_fun/0","title":"Oban.Job.changeset_fun/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:changeset_list/0","title":"Oban.Job.changeset_list/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:changeset_list_fun/0","title":"Oban.Job.changeset_list_fun/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:errors/0","title":"Oban.Job.errors/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:option/0","title":"Oban.Job.option/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:replace_by_state_option/0","title":"Oban.Job.replace_by_state_option/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:replace_option/0","title":"Oban.Job.replace_option/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:schedule_in_option/0","title":"Oban.Job.schedule_in_option/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:t/0","title":"Oban.Job.t/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:tags/0","title":"Oban.Job.tags/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:unique_field/0","title":"Oban.Job.unique_field/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:unique_option/0","title":"Oban.Job.unique_option/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:unique_period/0","title":"Oban.Job.unique_period/0","type":"type"},{"doc":"","ref":"Oban.Job.html#t:unique_state/0","title":"Oban.Job.unique_state/0","type":"type"},{"doc":"Migrations create and modify the database tables Oban needs to function. Usage To use migrations in your application you'll need to generate an Ecto.Migration that wraps calls to Oban.Migration : mix ecto.gen.migration add_oban Open the generated migration in your editor and call the up and down functions on Oban.Migration : defmodule MyApp.Repo.Migrations.AddOban do use Ecto.Migration def up , do : Oban.Migration . up ( ) def down , do : Oban.Migration . down ( ) end This will run all of Oban's versioned migrations for your database. Now, run the migration to create the table: mix ecto.migrate Migrations between versions are idempotent. As new versions are released, you may need to run additional migrations. To do this, generate a new migration: mix ecto.gen.migration upgrade_oban_to_v11 Open the generated migration in your editor and call the up and down functions on Oban.Migration , passing a version number: defmodule MyApp.Repo.Migrations.UpgradeObanToV11 do use Ecto.Migration def up , do : Oban.Migration . up ( version : 11 ) def down , do : Oban.Migration . down ( version : 11 ) end Isolation with Prefixes Oban supports namespacing through PostgreSQL schemas, also called &quot;prefixes&quot; in Ecto. With prefixes your jobs table can reside outside of your primary schema (usually public) and you can have multiple separate job tables. To use a prefix you first have to specify it within your migration: defmodule MyApp.Repo.Migrations.AddPrefixedObanJobsTable do use Ecto.Migration def up , do : Oban.Migrations . up ( prefix : &quot;private&quot; ) def down , do : Oban.Migrations . down ( prefix : &quot;private&quot; ) end The migration will create the &quot;private&quot; schema and all tables, functions and triggers within that schema. With the database migrated you'll then specify the prefix in your configuration: config :my_app , Oban , prefix : &quot;private&quot; , ... In some cases, for example if your &quot;private&quot; schema already exists and your database user in production doesn't have permissions to create a new schema, trying to create the schema from the migration will result in an error. In such situations, it may be useful to inhibit the creation of the &quot;private&quot; schema: defmodule MyApp.Repo.Migrations.AddPrefixedObanJobsTable do use Ecto.Migration def up , do : Oban.Migrations . up ( prefix : &quot;private&quot; , create_schema : false ) def down , do : Oban.Migrations . down ( prefix : &quot;private&quot; ) end Migrating Without Ecto If your application uses something other than Ecto for migrations, be it an external system or another ORM, it may be helpful to create plain SQL migrations for Oban database schema changes. The simplest mechanism for obtaining the SQL changes is to create the migration locally and run mix ecto.migrate --log-migrations-sql . That will log all of the generated SQL, which you can then paste into your migration system of choice. Alternatively, if you'd like a more automated approach, try using the oban_migations_sql project to generate up and down SQL migrations for you.","ref":"Oban.Migration.html","title":"Oban.Migration","type":"behaviour"},{"doc":"Run the down changes for all migrations between the current version and the initial version. Example Run all migrations from current version down to the first: Oban.Migration . down ( ) Run migrations down to and including a specified version: Oban.Migration . down ( version : 5 ) Run migrations in an alternate prefix: Oban.Migration . down ( prefix : &quot;payments&quot; )","ref":"Oban.Migration.html#down/1","title":"Oban.Migration.down/1","type":"function"},{"doc":"Migrates storage down to the previous version.","ref":"Oban.Migration.html#c:down/1","title":"Oban.Migration.down/1","type":"callback"},{"doc":"Check the latest version the database is migrated to. Example Oban.Migration . migrated_version ( )","ref":"Oban.Migration.html#migrated_version/1","title":"Oban.Migration.migrated_version/1","type":"function"},{"doc":"Identifies the last migrated version.","ref":"Oban.Migration.html#c:migrated_version/1","title":"Oban.Migration.migrated_version/1","type":"callback"},{"doc":"Run the up changes for all migrations between the initial version and the current version. Example Run all migrations up to the current version: Oban.Migration . up ( ) Run migrations up to a specified version: Oban.Migration . up ( version : 2 ) Run migrations in an alternate prefix: Oban.Migration . up ( prefix : &quot;payments&quot; ) Run migrations in an alternate prefix but don't try to create the schema: Oban.Migration . up ( prefix : &quot;payments&quot; , create_schema : false )","ref":"Oban.Migration.html#up/1","title":"Oban.Migration.up/1","type":"function"},{"doc":"Migrates storage up to the latest version.","ref":"Oban.Migration.html#c:up/1","title":"Oban.Migration.up/1","type":"callback"},{"doc":"Telemetry integration for event metrics, logging and error reporting. Initialization Events Oban emits the following telemetry event when an Oban supervisor is started: [:oban, :supervisor, :init] - when the Oban supervisor is started this will execute The initialization event contains the following measurements: :system_time - The system's time when Oban was started The initialization event contains the following metadata: :conf - The configuration used for the Oban supervisor instance :pid - The PID of the supervisor instance Job Events Oban emits the following telemetry events for each job: [:oban, :job, :start] — at the point a job is fetched from the database and will execute [:oban, :job, :stop] — after a job succeeds and the success is recorded in the database [:oban, :job, :exception] — after a job fails and the failure is recorded in the database All job events share the same details about the job that was executed. In addition, failed jobs provide the error type, the error itself, and the stacktrace. The following chart shows which metadata you can expect for each event: event measures metadata :start :system_time :conf , :job , :state :stop :duration , :queue_time :conf , :job , :state , :result :exception :duration , :queue_time :conf , :job , :state , :kind , :reason , :stacktrace Metadata :conf — the executing Oban instance's config :job — the executing Oban.Job :state — one of :success , :failure , :cancelled , :discard or :snoozed :result — the perform/1 return value, included unless job failed with an exception or crash For :exception events the metadata also includes details about what caused the failure. The :kind value is determined by how an error occurred. Here are the possible kinds: :error — from an {:error, error} return value. Some Erlang functions may also throw an :error tuple, which will be reported as :error . :exit — from a caught process exit :throw — from a caught value, this doesn't necessarily mean that an error occurred and the error value is unpredictable Engine Events Oban emits telemetry span events for the following Engine operations: [:oban, :engine, :init, :start | :stop | :exception] [:oban, :engine, :refresh, :start | :stop | :exception] [:oban, :engine, :put_meta, :start | :stop | :exception] event measures metadata :start :system_time :conf , :engine :stop :duration :conf , :engine :exception :duration :conf , :engine , :kind , :reason , :stacktrace Events for bulk operations also include :jobs for the :stop event: [:oban, :engine, :cancel_all_jobs, :start | :stop | :exception] [:oban, :engine, :fetch_jobs, :start | :stop | :exception] [:oban, :engine, :insert_all_jobs, :start | :stop | :exception] [:oban, :engine, :prune_jobs, :start | :stop | :exception] [:oban, :engine, :retry_all_jobs, :start | :stop | :exception] [:oban, :engine, :stage_jobs, :start | :stop | :exception] event measures metadata :start :system_time :conf , :engine :stop :duration :conf , :engine , :jobs :exception :duration :conf , :engine , :kind , :reason , :stacktrace Events for job-level Engine operations also include the job [:oban, :engine, :cancel_job, :start | :stop | :exception] [:oban, :engine, :complete_job, :start | :stop | :exception] [:oban, :engine, :discard_job, :start | :stop | :exception] [:oban, :engine, :error_job, :start | :stop | :exception] [:oban, :engine, :insert_job, :start | :stop | :exception] [:oban, :engine, :retry_job, :start | :stop | :exception] [:oban, :engine, :snooze_job, :start | :stop | :exception] event measures metadata :start :system_time :conf , :engine , :job :stop :duration :conf , :engine , :job :exception :duration :conf , :engine , :job , :kind , :reason , :stacktrace Metadata :conf — the Oban supervisor's config :engine — the module of the engine used :job - the Oban.Job in question :jobs — zero or more maps with the queue , state for each modified job :kind , :reason , :stacktrace — see the explanation in job metadata above Notifier Events Oban emits a telemetry span event each time the Notifier is triggered: [:oban, :notifier, :notify, :start | :stop | :exception] event measures metadata :start :system_time :conf , :channel , :payload :stop :duration :conf , :channel , :payload :exception :duration :conf , :channel , :payload , :kind , :reason , :stacktrace Metadata :conf — the Oban supervisor's config :channel — the channel on which the notification was sent :payload - the decoded payload that was sent :kind , :reason , :stacktrace — see the explanation in job metadata above Plugin Events All the Oban plugins emit telemetry events under the [:oban, :plugin, *] pattern (where * is either :init , :start , :stop , or :exception ). You can filter out for plugin events by looking into the metadata of the event and checking the value of :plugin . The :plugin field is the plugin module that emitted the event. For example, to get Oban.Plugins.Cron specific events, you can filter for telemetry events with a metadata key/value of plugin: Oban.Plugins.Cron . Oban emits the following telemetry event whenever a plugin executes (be sure to check the documentation for each plugin as each plugin can also add additional metadata specific to the plugin): [:oban, :plugin, :init] — when the plugin first initializes [:oban, :plugin, :start] — when the plugin beings performing its work [:oban, :plugin, :stop] — after the plugin completes its work [:oban, :plugin, :exception] — when the plugin encounters an error The following chart shows which metadata you can expect for each event: event measures metadata :init :conf , :plugin :start :system_time :conf , :plugin :stop :duration :conf , :plugin :exception :duration :conf , :plugin , :kind , :reason , :stacktrace Peer Events Oban emits a telemetry span event each time an Oban Peer election occurs: [:oban, :peer, :election, :start | :stop | :exception] event measures metadata :start :system_time :conf , :leader , :peer , :stop :duration :conf , :leader , :peer , :exception :duration :conf , :leader , :peer , :kind , :reason , :stacktrace Metadata :conf , :kind , :reason , :stacktrace — see the explanation in notifier metadata above :leader — whether the peer is the current leader :peer — the module used for peering Default Logger A default log handler that emits structured JSON is provided, see attach_default_logger/0 for usage. Otherwise, if you would prefer more control over logging or would like to instrument events you can write your own handler. Here is an example of the JSON output for the job:stop event: { &quot;args&quot;:{&quot;action&quot;:&quot;OK&quot;,&quot;ref&quot;:1}, &quot;attempt&quot;:1, &quot;duration&quot;:4327295, &quot;event&quot;:&quot;job:stop&quot;, &quot;id&quot;:123, &quot;max_attempts&quot;:20, &quot;meta&quot;:{}, &quot;queue&quot;:&quot;alpha&quot;, &quot;queue_time&quot;:3127905, &quot;source&quot;:&quot;oban&quot;, &quot;state&quot;:&quot;success&quot;, &quot;tags&quot;:[], &quot;worker&quot;:&quot;Oban.Integration.Worker&quot; } All timing measurements are recorded as native time units but logged in microseconds. Examples A handler that only logs a few details about failed jobs: defmodule MicroLogger do require Logger def handle_event ( [ :oban , :job , :exception ] , %{ duration : duration } , meta , nil ) do Logger . warn ( &quot;[ \#{ meta . queue } ] \#{ meta . worker } failed in \#{ duration } &quot; ) end end :telemetry . attach ( &quot;oban-logger&quot; , [ :oban , :job , :exception ] , &amp; MicroLogger . handle_event / 4 , nil ) Another great use of execution data is error reporting. Here is an example of integrating with Honeybadger , but only reporting jobs that have failed 3 times or more: defmodule ErrorReporter do def handle_event ( [ :oban , :job , :exception ] , _ , %{ attempt : attempt } = meta , _ ) do if attempt &gt;= 3 do context = Map . take ( meta , [ :id , :args , :queue , :worker ] ) Honeybadger . notify ( meta . reason , metadata : context , stacktrace : meta . stacktrace ) end end end :telemetry . attach ( &quot;oban-errors&quot; , [ :oban , :job , :exception ] , &amp; ErrorReporter . handle_event / 4 , [ ] )","ref":"Oban.Telemetry.html","title":"Oban.Telemetry","type":"module"},{"doc":"Attaches a default structured JSON Telemetry handler for logging. This function attaches a handler that outputs logs with the following fields: args — a map of the job's raw arguments attempt — the job's execution atttempt duration — the job's runtime duration, in the native time unit event — either job:stop or job:exception depending on reporting telemetry event error — a formatted error banner, without the extended stacktrace id — the job's id meta — a map of the job's raw metadata queue — the job's queue source — always &quot;oban&quot; state — the execution state, one of &quot;success&quot;, &quot;failure&quot;, &quot;cancelled&quot;, &quot;discard&quot;, or &quot;snoozed&quot; system_time — when the job started, in microseconds tags — the job's tags worker — the job's worker module Options :level — The log level to use for logging output, defaults to :info . :encode — Whether to encode log output as JSON, defaults to true Examples Attach a logger at the default :info level with JSON encoding: :ok = Oban.Telemetry . attach_default_logger ( ) Attach a logger at the :debug level: :ok = Oban.Telemetry . attach_default_logger ( level : :debug ) Attach a logger with JSON logging disabled: :ok = Oban.Telemetry . attach_default_logger ( encode : false )","ref":"Oban.Telemetry.html#attach_default_logger/1","title":"Oban.Telemetry.attach_default_logger/1","type":"function"},{"doc":"Undoes Oban.Telemetry.attach_default_logger/1 by detaching the attached logger. Examples Detach a previously attached logger: :ok = Oban.Telemetry . attach_default_logger ( ) :ok = Oban.Telemetry . detach_default_logger ( ) Attempt to detach when a logger wasn't attached: { :error , :not_found } = Oban.Telemetry . detach_default_logger ( )","ref":"Oban.Telemetry.html#detach_default_logger/0","title":"Oban.Telemetry.detach_default_logger/0","type":"function"},{"doc":"This module simplifies testing workers and making assertions about enqueued jobs when testing in :manual mode. Assertions may be made on any property of a job, but you'll typically want to check by args , queue or worker . If you're using namespacing through PostgreSQL schemas, also called &quot;prefixes&quot; in Ecto, you should use the prefix option when doing assertions about enqueued jobs during testing. By default the prefix option is public . Using in Tests The most convenient way to use Oban.Testing is to use the module: use Oban.Testing , repo : MyApp.Repo That will define the helper functions you'll use to make assertions on the jobs that should (or should not) be inserted in the database while testing. Along with the repo you can also specify an alternate prefix to use in all assertions: use Oban.Testing , repo : MyApp.Repo , prefix : &quot;business&quot; Some example assertions: # Assert that a job was already enqueued assert_enqueued worker : MyWorker , args : %{ id : 1 } # Assert that a job was enqueued or will be enqueued in the next 100ms assert_enqueued [ worker : MyWorker , args : %{ id : 1 } ] , 100 # Refute that a job was already enqueued refute_enqueued queue : &quot;special&quot; , args : %{ id : 2 } # Refute that a job was already enqueued or would be enqueued in the next 100ms refute_enqueued queue : &quot;special&quot; , args : %{ id : 2 } , 100 # Make assertions on a list of all jobs matching some options assert [ %{ args : %{ &quot;id&quot; =&gt; 1 } } ] = all_enqueued ( worker : MyWorker ) # Assert that no jobs are enqueued in any queues assert [ ] = all_enqueued ( ) Note that the final example, using all_enqueued/1 , returns a raw list of matching jobs and does not make an assertion by itself. This makes it possible to test using pattern matching at the expense of being more verbose. Example Given a simple module that enqueues a job: defmodule MyApp.Business do def work ( args ) do args |&gt; Oban.Job . new ( worker : MyApp.Worker , queue : :special ) |&gt; Oban . insert! ( ) end end The behaviour can be exercised in your test code: defmodule MyApp.BusinessTest do use ExUnit.Case , async : true use Oban.Testing , repo : MyApp.Repo alias MyApp.Business test &quot;jobs are enqueued with provided arguments&quot; do Business . work ( %{ id : 1 , message : &quot;Hello!&quot; } ) assert_enqueued worker : MyApp.Worker , args : %{ id : 1 , message : &quot;Hello!&quot; } end end Matching Scheduled Jobs and Timestamps In order to assert a job has been scheduled at a certain time, you will need to match against the scheduled_at attribute of the enqueued job. in_an_hour = DateTime . add ( DateTime . utc_now ( ) , 3600 , :second ) assert_enqueued worker : MyApp.Worker , scheduled_at : in_an_hour By default, Oban will apply a 1 second delta to all timestamp fields of jobs, so that small deviations between the actual value and the expected one are ignored. You may configure this delta by passing a tuple of value and a delta option (in seconds) to corresponding keyword: assert_enqueued worker : MyApp.Worker , scheduled_at : { in_an_hour , delta : 10 } Adding to Case Templates To include helpers in all of your tests you can add it to your case template: defmodule MyApp.DataCase do use ExUnit.CaseTemplate using do quote do use Oban.Testing , repo : MyApp.Repo import Ecto import Ecto.Changeset import Ecto.Query import MyApp.DataCase alias MyApp.Repo end end end","ref":"Oban.Testing.html","title":"Oban.Testing","type":"module"},{"doc":"Retrieve all currently enqueued jobs matching a set of options. Only jobs matching all of the provided arguments will be returned. Additionally, jobs are returned in descending order where the most recently enqueued job will be listed first. Examples Assert based on only some of a job's args: assert [ %{ args : %{ &quot;id&quot; =&gt; 1 } } ] = all_enqueued ( worker : MyWorker ) Assert that exactly one job was inserted for a queue: assert [ % Oban.Job { } ] = all_enqueued ( queue : :alpha ) Assert that there aren't any jobs enqueued for any queues or workers: assert [ ] = all_enqueued ( )","ref":"Oban.Testing.html#all_enqueued/2","title":"Oban.Testing.all_enqueued/2","type":"function"},{"doc":"Assert that a job with particular options has been enqueued. Only values for the provided arguments will be checked. For example, an assertion made on worker: &quot;MyWorker&quot; will match any jobs for that worker, regardless of the queue or args.","ref":"Oban.Testing.html#assert_enqueued/2","title":"Oban.Testing.assert_enqueued/2","type":"function"},{"doc":"Assert that a job with particular options is or will be enqueued within a timeout period. See assert_enqueued/2 for additional details. Examples Assert that a job will be enqueued in the next 100ms: assert_enqueued [ worker : MyWorker ] , 100","ref":"Oban.Testing.html#assert_enqueued/3","title":"Oban.Testing.assert_enqueued/3","type":"function"},{"doc":"Construct a job and execute it with a worker module. This reduces boilerplate when constructing jobs for unit tests and checks for common pitfalls. For example, it automatically converts args to string keys before calling perform/1 , ensuring that perform clauses aren't erroneously trying to match atom keys. The helper makes the following assertions: That the worker implements the Oban.Worker behaviour That the options provided build a valid job That the return is valid, e.g. :ok , {:ok, value} , {:error, value} etc. If all of the assertions pass then the function returns the result of perform/1 for you to make additional assertions on. Examples Successfully execute a job with some string arguments: assert :ok = perform_job ( MyWorker , %{ &quot;id&quot; =&gt; 1 } ) Successfully execute a job and assert that it returns an error tuple: assert { :error , _ } = perform_job ( MyWorker , %{ &quot;bad&quot; =&gt; &quot;arg&quot; } ) Execute a job with the args keys automatically stringified: assert :ok = perform_job ( MyWorker , %{ id : 1 } ) Exercise custom attempt handling within a worker by passing options: assert :ok = perform_job ( MyWorker , %{ } , attempt : 42 ) Cause a test failure because the provided worker isn't real: assert :ok = perform_job ( Vorker , %{ &quot;id&quot; =&gt; 1 } )","ref":"Oban.Testing.html#perform_job/3","title":"Oban.Testing.perform_job/3","type":"function"},{"doc":"Refute that a job with particular options has been enqueued. See assert_enqueued/2 for additional details.","ref":"Oban.Testing.html#refute_enqueued/2","title":"Oban.Testing.refute_enqueued/2","type":"function"},{"doc":"Refute that a job with particular options is or will be enqueued within a timeout period. The minimum refute timeout is 10ms. See assert_enqueued/2 for additional details. Examples Refute that a job will be enqueued in the next 100ms: refute_enqueued [ worker : MyWorker ] , 100","ref":"Oban.Testing.html#refute_enqueued/3","title":"Oban.Testing.refute_enqueued/3","type":"function"},{"doc":"Change the testing mode within the context of a function. Only :manual and :inline mode are supported, as :disabled implies that supervised queues and plugins are running and this function won't start any processes. Examples Switch to :manual mode when an Oban instance is configured for :inline testing: Oban.Testing . with_testing_mode ( :manual , fn -&gt; Oban . insert ( MyWorker . new ( %{ id : 123 } ) ) assert_enqueued worker : MyWorker , args : %{ id : 123 } end ) Visa-versa, switch to :inline mode: Oban.Testing . with_testing_mode ( :inline , fn -&gt; { :ok , % Job { state : &quot;completed&quot; } } = Oban . insert ( MyWorker . new ( %{ id : 123 } ) ) end )","ref":"Oban.Testing.html#with_testing_mode/2","title":"Oban.Testing.with_testing_mode/2","type":"function"},{"doc":"","ref":"Oban.Testing.html#t:perform_opts/0","title":"Oban.Testing.perform_opts/0","type":"type"},{"doc":"Defines a behavior and macro to guide the creation of worker modules. Worker modules do the work of processing a job. At a minimum they must define a perform/1 function, which is called with the full Oban.Job struct. Defining Workers Worker modules are defined by using Oban.Worker . A bare use Oban.Worker invocation sets a worker with these defaults: :max_attempts — 20 :priority — 0 :queue — :default :unique — no uniqueness set To create a minimum worker using the defaults, including the default queue: defmodule MyApp.Workers.Basic do use Oban.Worker @impl Oban.Worker def perform ( % Oban.Job { args : args } ) do IO . inspect ( args ) :ok end end The following example defines a complex worker module to process jobs in the events queue. It then dials down the priority from 0 to 1, limits retrying on failures to 10 attempts, adds a &quot;business&quot; tag, and ensures that duplicate jobs aren't enqueued within a 30 second period: defmodule MyApp.Workers.Business do use Oban.Worker , queue : :events , priority : 1 , max_attempts : 10 , tags : [ &quot;business&quot; ] , unique : [ period : 30 ] @impl Oban.Worker def perform ( % Oban.Job { attempt : attempt } ) when attempt &gt; 3 do IO . inspect ( attempt ) end def perform ( job ) do IO . inspect ( job . args ) end end The perform/1 function receives an Oban.Job struct as an argument. This allows workers to change the behavior of perform/1 based on attributes of the job, e.g. the args, number of execution attempts, or when it was inserted. The value returned from perform/1 can control whether the job is a success or a failure: :ok or {:ok, value} — the job is successful and marked as completed . The value from success tuples is ignored. {:cancel, reason} — cancel executing the job and stop retrying it. An error is recorded using the provided reason . The job is marked as cancelled . {:error, error} — the job failed, record the error. If max_attempts has not been reached already, the job is marked as retryable and scheduled to run again. Otherwise, the job is marked as discarded and won't be retried. {:snooze, seconds} — mark the job as snoozed and schedule it to run again seconds in the future. See Snoozing for more details. In addition to explicit return values, any unhandled exception , exit or throw will fail the job and schedule a retry if possible. As an example of error tuple handling, this worker will return an error tuple when the value is less than one: defmodule MyApp.Workers.ErrorExample do use Oban.Worker @impl Worker def perform ( %{ args : %{ &quot;value&quot; =&gt; value } } ) do if value &gt; 1 do :ok else { :error , &quot;invalid value given: &quot; &lt;&gt; inspect ( value ) } end end end The error tuple is wrapped in an Oban.PerformError with a formatted message. The error tuple itself is available through the exception's :reason field. Enqueuing Jobs All workers implement a new/2 function that converts an args map into a job changeset suitable for inserting into the database for later execution: %{ in_the : &quot;business&quot; , of_doing : &quot;business&quot; } |&gt; MyApp.Workers.Business . new ( ) |&gt; Oban . insert ( ) The worker's defaults may be overridden by passing options: %{ vote_for : &quot;none of the above&quot; } |&gt; MyApp.Workers.Business . new ( queue : &quot;special&quot; , max_attempts : 5 ) |&gt; Oban . insert ( ) Uniqueness options may also be overridden by passing options: %{ expensive : &quot;business&quot; } |&gt; MyApp.Workers.Business . new ( unique : [ period : 120 , fields : [ :worker ] ] ) |&gt; Oban . insert ( ) Note that unique options aren't merged, they are overridden entirely. See Oban.Job for all available options. Customizing Backoff When jobs fail they may be retried again in the future using a backoff algorithm. By default the backoff is exponential with a fixed padding of 15 seconds and a small amount of jitter. The jitter helps to prevent jobs that fail simultaneously from consistently retrying at the same time. With the default backoff behavior, the 20th attempt will occur around 12 days after the first attempt. If the default strategy is too aggressive or otherwise unsuited to your app's workload you can define a custom backoff function using the backoff/1 callback. The following worker defines a backoff/1 function that delays retries using a variant of the historic Resque/Sidekiq algorithm: defmodule MyApp.SidekiqBackoffWorker do use Oban.Worker @impl Worker def backoff ( % Job { attempt : attempt } ) do trunc ( :math . pow ( attempt , 4 ) + 15 + :rand . uniform ( 30 ) * attempt ) end @impl Worker def perform ( _job ) do :do_business end end Here are some alternative backoff strategies to consider: constant — delay by a fixed number of seconds, e.g. 1→15, 2→15, 3→15 linear — delay for the same number of seconds as the current attempt, e.g. 1→1, 2→2, 3→3 squared — delay by attempt number squared, e.g. 1→1, 2→4, 3→9 sidekiq — delay by a base amount plus some jitter, e.g. 1→32, 2→61, 3→135 Contextual Backoff Any error, catch or throw is temporarily recorded in the job's unsaved_error map. The unsaved error map can be used by backoff/1 to calculate a custom backoff based on the exact error that failed the job. In this example the backoff/1 callback checks to see if the error was due to rate limiting and adjusts the backoff accordingly: defmodule MyApp.ApiWorker do use Oban.Worker @five_minutes 5 * 60 @impl Worker def perform ( %{ args : args } ) do MyApp . make_external_api_call ( args ) end @impl Worker def backoff ( % Job { attempt : attempt , unsaved_error : unsaved_error } ) do %{ kind : _ , reason : reason , stacktrace : _ } = unsaved_error case reason do % MyApp.ApiError { status : 429 } -&gt; @five_minutes _ -&gt; trunc ( :math . pow ( attempt , 4 ) ) end end end Snoozing Jobs When returning {:snooze, snooze_time} in perform/1 , the job is postponed for at least snooze_time seconds. Snoozing is done by incrementing the job's max_attempts field and scheduling execution for snooze_time seconds in the future. Snoozing does not change the number of retries remaining on the job, but it does increment the attempt number each time the job snoozes, which will affect the default backoff retry algorithm. The example below demonstrates a backoff/1 that compensates for snoozing: defmodule MyApp.SnoozingWorker do @max_attempts 20 use Oban.Worker , max_attempts : @max_attempts @impl Worker def backoff ( % Job { } = job ) do corrected_attempt = @max_attempts - ( job . max_attempts - job . attempt ) Worker . backoff ( %{ job | attempt : corrected_attempt } ) end @impl Worker def perform ( job ) do if MyApp . something? ( job ) , do : :ok , else : { :snooze , 60 } end end Limiting Execution Time By default, individual jobs may execute indefinitely. If this is undesirable you may define a timeout in milliseconds with the timeout/1 callback on your worker module. For example, to limit a worker's execution time to 30 seconds: def MyApp.Worker do use Oban.Worker @impl Oban.Worker def perform ( _job ) do something_that_may_take_a_long_time ( ) :ok end @impl Oban.Worker def timeout ( _job ) , do : :timer . seconds ( 30 ) end The timeout/1 function accepts an Oban.Job struct, so you can customize the timeout using any job attributes. Define the timeout value through job args: def timeout ( % _ { args : %{ &quot;timeout&quot; =&gt; timeout } } ) , do : timeout Define the timeout based on the number of attempts: def timeout ( % _ { attempt : attempt } ) , do : attempt * :timer . seconds ( 5 )","ref":"Oban.Worker.html","title":"Oban.Worker","type":"behaviour"},{"doc":"Calculate the execution backoff. In this context backoff specifies the number of seconds to wait before retrying a failed job. Defaults to an exponential algorithm with a minimum delay of 15 seconds and a small amount of jitter.","ref":"Oban.Worker.html#c:backoff/1","title":"Oban.Worker.backoff/1","type":"callback"},{"doc":"Resolve a module from a worker string. Examples iex&gt; Oban.Worker . from_string ( &quot;Oban.Integration.Worker&quot; ) { :ok , Oban.Integration.Worker } iex&gt; defmodule NotAWorker , do : [ ] ...&gt; Oban.Worker . from_string ( &quot;NotAWorker&quot; ) { :error , % RuntimeError { message : &quot;module is not a worker: NotAWorker&quot; } } iex&gt; Oban.Worker . from_string ( &quot;RandomWorker&quot; ) { :error , % RuntimeError { message : &quot;unknown worker: RandomWorker&quot; } }","ref":"Oban.Worker.html#from_string/1","title":"Oban.Worker.from_string/1","type":"function"},{"doc":"Build a job changeset for this worker with optional overrides. See Oban.Job.new/2 for the available options.","ref":"Oban.Worker.html#c:new/2","title":"Oban.Worker.new/2","type":"callback"},{"doc":"The perform/1 function is called to execute a job. Each perform/1 function should return :ok or a success tuple. When the return is an error tuple, an uncaught exception or a throw then the error is recorded and the job may be retried if there are any attempts remaining. Note that the args map provided to perform/1 will always have string keys, regardless of the key type when the job was enqueued. The args are stored as jsonb in PostgreSQL and the serialization process automatically stringifies all keys.","ref":"Oban.Worker.html#c:perform/1","title":"Oban.Worker.perform/1","type":"callback"},{"doc":"Set a job's maximum execution time in milliseconds. Jobs that exceed the time limit are considered a failure and may be retried. Defaults to :infinity .","ref":"Oban.Worker.html#c:timeout/1","title":"Oban.Worker.timeout/1","type":"callback"},{"doc":"Return a string representation of a worker module. This is particularly useful for normalizing worker names when building custom Ecto queries. Examples iex&gt; Oban.Worker . to_string ( MyApp.SomeWorker ) &quot;MyApp.SomeWorker&quot; iex&gt; Oban.Worker . to_string ( Elixir.MyApp.SomeWorker ) &quot;MyApp.SomeWorker&quot; iex&gt; Oban.Worker . to_string ( &quot;Elixir.MyApp.SomeWorker&quot; ) &quot;MyApp.SomeWorker&quot;","ref":"Oban.Worker.html#to_string/1","title":"Oban.Worker.to_string/1","type":"function"},{"doc":"","ref":"Oban.Worker.html#t:result/0","title":"Oban.Worker.result/0","type":"type"},{"doc":"","ref":"Oban.Worker.html#t:t/0","title":"Oban.Worker.t/0","type":"type"},{"doc":"Periodically enqueue jobs through CRON based scheduling. This plugin registers workers a cron-like schedule and enqueues jobs automatically. Periodic jobs are declared as a list of {cron, worker} or {cron, worker, options} tuples. 🌟 DynamicCron This plugin only loads the crontab statically, at boot time. To configure cron schedules dynamically at runtime, across your entire cluster, see the DynamicCron plugin in Oban Pro . Using the Plugin Schedule various jobs using {expr, worker} and {expr, worker, opts} syntaxes: config :my_app , Oban , plugins : [ { Oban.Plugins.Cron , crontab : [ { &quot;* * * * *&quot; , MyApp.MinuteWorker } , { &quot;0 * * * *&quot; , MyApp.HourlyWorker , args : %{ custom : &quot;arg&quot; } } , { &quot;0 0 * * *&quot; , MyApp.DailyWorker , max_attempts : 1 } , { &quot;0 12 * * MON&quot; , MyApp.MondayWorker , queue : :scheduled , tags : [ &quot;mondays&quot; ] } , { &quot;@daily&quot; , MyApp.AnotherDailyWorker } ] } ] Options :crontab — a list of cron expressions that enqueue jobs on a periodic basis. See Periodic Jobs in the Oban module docs for syntax and details. :timezone — which timezone to use when scheduling cron jobs. To use a timezone other than the default of &quot;Etc/UTC&quot; you must have a timezone database like tz installed and configured. Instrumenting with Telemetry The Oban.Plugins.Cron plugin adds the following metadata to the [:oban, :plugin, :stop] event: :jobs - a list of jobs that were inserted into the database","ref":"Oban.Plugins.Cron.html","title":"Oban.Plugins.Cron","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Plugins.Cron.html#child_spec/1","title":"Oban.Plugins.Cron.child_spec/1","type":"function"},{"doc":"Parse a crontab expression into a cron struct. This is provided as a convenience for validating and testing cron expressions. As such, the cron struct itself is opaque and the internals may change at any time. The parser can handle common expressions that use minutes, hours, days, months and weekdays, along with ranges and steps. It also supports common extensions, also called nicknames. Returns {:error, %ArgumentError{}} with a detailed error if the expression cannot be parsed. Nicknames The following special nicknames are supported in addition to standard cron expressions: @yearly —Run once a year, &quot;0 0 1 1 *&quot; @annually —Same as @yearly @monthly —Run once a month, &quot;0 0 1 &quot; @weekly —Run once a week, &quot;0 0 0&quot; @daily —Run once a day, &quot;0 0 *&quot; @midnight —Same as @daily @hourly —Run once an hour, &quot;0 &quot; @reboot —Run once at boot Examples iex&gt; Oban.Plugins.Cron . parse ( &quot;@hourly&quot; ) { :ok , # Oban.Cron.Expression &lt; ... &gt; } iex&gt; Oban.Plugins.Cron . parse ( &quot;0 * * * *&quot; ) { :ok , # Oban.Cron.Expression &lt; ... &gt; } iex&gt; Oban.Plugins.Cron . parse ( &quot;60 * * * *&quot; ) { :error , % ArgumentError { message : &quot;expression field 60 is out of range 0..59&quot; } }","ref":"Oban.Plugins.Cron.html#parse/1","title":"Oban.Plugins.Cron.parse/1","type":"function"},{"doc":"","ref":"Oban.Plugins.Cron.html#t:cron_input/0","title":"Oban.Plugins.Cron.cron_input/0","type":"type"},{"doc":"","ref":"Oban.Plugins.Cron.html#t:expression/0","title":"Oban.Plugins.Cron.expression/0","type":"opaque"},{"doc":"","ref":"Oban.Plugins.Cron.html#t:option/0","title":"Oban.Plugins.Cron.option/0","type":"type"},{"doc":"The Gossip plugin uses PubSub to periodically exchange queue state information between all interested nodes. This allows Oban instances to broadcast state information regardless of which engine they are using, and without storing anything in the database. Gossip enables real-time updates across an entire cluster, and is essential to the operation of UIs like Oban Web. The Gossip plugin entirely replaced heartbeats and the legacy oban_beats table. Using the Plugin The following example demonstrates using the plugin without any configuration, which will broadcast the state of each local queue every 1 second: config :my_app , Oban , plugins : [ Oban.Plugins.Gossip ] , ... Override the default options to broadcast every 5 seconds: config :my_app , Oban , plugins : [ { Oban.Plugins.Gossip , interval : :timer . seconds ( 5 ) } ] , ... Options :interval — the number of milliseconds between gossip broadcasts Instrumenting with Telemetry The Oban.Plugins.Gossip plugin adds the following metadata to the [:oban, :plugin, :stop] event: :gossip_count - the number of queues that had activity broadcasted","ref":"Oban.Plugins.Gossip.html","title":"Oban.Plugins.Gossip","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Plugins.Gossip.html#child_spec/1","title":"Oban.Plugins.Gossip.child_spec/1","type":"function"},{"doc":"","ref":"Oban.Plugins.Gossip.html#t:option/0","title":"Oban.Plugins.Gossip.option/0","type":"type"},{"doc":"Naively transition jobs stuck executing back to available . The Lifeline plugin periodically rescues orphaned jobs, i.e. jobs that are stuck in the executing state because the node was shut down before the job could finish. Rescuing is purely based on time, rather than any heuristic about the job's expected execution time or whether the node is still alive. If an executing job has exhausted all attempts, the Lifeline plugin will mark it discarded rather than available . 🌟 DynamicLifeline This plugin may transition jobs that are genuinely executing and cause duplicate execution. For more accurate rescuing or to rescue jobs that have exhausted retry attempts see the DynamicLifeline plugin in Oban Pro . Using the Plugin Rescue orphaned jobs that are still executing after the default of 60 minutes: config :my_app , Oban , plugins : [ Oban.Plugins.Lifeline ] , ... Override the default period to rescue orphans after a more aggressive period of 5 minutes: config :my_app , Oban , plugins : [ { Oban.Plugins.Lifeline , rescue_after : :timer . minutes ( 5 ) } ] , ... Options :interval — the number of milliseconds between rescue attempts. The default is 60_000ms . :rescue_after — the maximum amount of time, in milliseconds, that a job may execute before being rescued. 60 minutes by default, and rescuing is performed once a minute. Instrumenting with Telemetry The Oban.Plugins.Lifeline plugin adds the following metadata to the [:oban, :plugin, :stop] event: :rescued_jobs — a list of jobs transitioned back to available :discarded_jobs — a list of jobs transitioned to discarded Note: jobs only include id , queue , state fields.","ref":"Oban.Plugins.Lifeline.html","title":"Oban.Plugins.Lifeline","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Plugins.Lifeline.html#child_spec/1","title":"Oban.Plugins.Lifeline.child_spec/1","type":"function"},{"doc":"","ref":"Oban.Plugins.Lifeline.html#t:option/0","title":"Oban.Plugins.Lifeline.option/0","type":"type"},{"doc":"Periodically delete completed, cancelled and discarded jobs based on age. Using the Plugin The following example demonstrates using the plugin without any configuration, which will prune jobs older than the default of 60 seconds: config :my_app , Oban , plugins : [ Oban.Plugins.Pruner ] , ... Override the default options to prune jobs after 5 minutes: config :my_app , Oban , plugins : [ { Oban.Plugins.Pruner , max_age : 300 } ] , ... 🌟 DynamicPruner To prune on a cron-style schedule, retain jobs by a limit, or provide overrides for specific queues, workers, and job states; see Oban Pro's DynamicPruner . Options :interval — the number of milliseconds between pruning attempts. The default is 30_000ms . :limit — the maximum number of jobs to prune at one time. The default is 10,000 to prevent request timeouts. Applications that steadily generate more than 10k jobs a minute should increase this value. :max_age — the number of seconds after which a job may be pruned. Defaults to 60s. Instrumenting with Telemetry The Oban.Plugins.Pruner plugin adds the following metadata to the [:oban, :plugin, :stop] event: :pruned_jobs - the jobs that were deleted from the database Note: jobs only include id , queue , state fields.","ref":"Oban.Plugins.Pruner.html","title":"Oban.Plugins.Pruner","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Plugins.Pruner.html#child_spec/1","title":"Oban.Plugins.Pruner.child_spec/1","type":"function"},{"doc":"","ref":"Oban.Plugins.Pruner.html#t:option/0","title":"Oban.Plugins.Pruner.option/0","type":"type"},{"doc":"Periodically rebuild indexes to minimize database bloat. Over time various Oban indexes may grow without VACUUM cleaning them up properly. When this happens, rebuilding the indexes will release bloat. The plugin uses REINDEX with the CONCURRENTLY option to rebuild without taking any locks that prevent concurrent inserts, updates, or deletes on the table. Note: This plugin requires the CONCURRENT option, which is only available in Postgres 12 and above. Using the Plugin By default, the plugin will reindex once a day, at midnight UTC: config :my_app , Oban , plugins : [ Oban.Plugins.Reindexer ] , ... To run on a different schedule you can provide a cron expression. For example, you could use the &quot;@weekly&quot; shorthand to run once a week on Sunday: config :my_app , Oban , plugins : [ { Oban.Plugins.Reindexer , schedule : &quot;@weekly&quot; } ] , ... Options :indexes — a list of indexes to reindex on the oban_jobs table. Defaults to only the oban_jobs_args_index and oban_jobs_meta_index . :schedule — a cron expression that controls when to reindex. Defaults to &quot;@midnight&quot; . :timeout - time in milliseconds to wait for each query call to finish. Defaults to 15 seconds. :timezone — which timezone to use when evaluating the schedule. To use a timezone other than the default of &quot;Etc/UTC&quot; you must have a timezone database like tz installed and configured.","ref":"Oban.Plugins.Reindexer.html","title":"Oban.Plugins.Reindexer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Plugins.Reindexer.html#child_spec/1","title":"Oban.Plugins.Reindexer.child_spec/1","type":"function"},{"doc":"","ref":"Oban.Plugins.Reindexer.html#t:option/0","title":"Oban.Plugins.Reindexer.option/0","type":"type"},{"doc":"Forced polling mode for local queues. This plugin is superseded by the new hybrid staging.","ref":"Oban.Plugins.Repeater.html","title":"Oban.Plugins.Repeater","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Plugins.Repeater.html#child_spec/1","title":"Oban.Plugins.Repeater.child_spec/1","type":"function"},{"doc":"The Config struct validates and encapsulates Oban instance state. Typically, you won't use the Config module directly. Oban automatically creates a Config struct on initialization and passes it through to all supervised children with the :conf key. To fetch a running Oban supervisor's config, see Oban.config/1 .","ref":"Oban.Config.html","title":"Oban.Config","type":"module"},{"doc":"Generate a Config struct after normalizing and verifying Oban options. See Oban.start_link/1 for a comprehensive description of available options. Example Generate a minimal config with only a :repo : Oban.Config . new ( repo : Oban.Test.Repo )","ref":"Oban.Config.html#new/1","title":"Oban.Config.new/1","type":"function"},{"doc":"Verify configuration options. This helper is used by new/1 , and therefore by Oban.start_link/1 , to verify configuration options when an Oban supervisor starts. It is provided publicly to aid in configuration testing, as test config may differ from prod config. Example Validating top level options: iex&gt; Oban.Config . validate ( name : Oban ) :ok iex&gt; Oban.Config . validate ( name : Oban , log : false ) :ok iex&gt; Oban.Config . validate ( node : { :not , :binary } ) { :error , &quot;expected :node to be a non-empty binary, got: {:not, :binary}&quot; } iex&gt; Oban.Config . validate ( plugins : true ) { :error , &quot;expected :plugins to be a list, got: true&quot; } Validating plugin options: iex&gt; Oban.Config . validate ( plugins : [ { Oban.Plugins.Pruner , max_age : 60 } ] ) :ok iex&gt; Oban.Config . validate ( plugins : [ { Oban.Plugins.Pruner , max_age : 0 } ] ) { :error , &quot;expected :max_age to be a positive integer, got: 0&quot; }","ref":"Oban.Config.html#validate/1","title":"Oban.Config.validate/1","type":"function"},{"doc":"","ref":"Oban.Config.html#t:t/0","title":"Oban.Config.t/0","type":"type"},{"doc":"Defines an Engine for job orchestration. Engines are responsible for all non-plugin database interaction, from inserting through executing jobs. Oban ships with three Engine implementations: Basic — The default engine for development, production, and manual testing mode. Inline — Designed specifically for testing, it executes jobs immediately, in-memory, as they are inserted. Lite - The engine for running Oban using SQLite3. 🌟 SmartEngine The Basic engine lacks advanced functionality such as global limits, rate limits, and unique bulk insert. For those features and more, see the SmartEngine in Oban Pro .","ref":"Oban.Engine.html","title":"Oban.Engine","type":"behaviour"},{"doc":"Mark many executing , available , scheduled or retryable job as cancelled to prevent them from running.","ref":"Oban.Engine.html#c:cancel_all_jobs/2","title":"Oban.Engine.cancel_all_jobs/2","type":"callback"},{"doc":"Mark an executing , available , scheduled or retryable job as cancelled to prevent it from running.","ref":"Oban.Engine.html#c:cancel_job/2","title":"Oban.Engine.cancel_job/2","type":"callback"},{"doc":"Format engine meta in a digestible format for queue inspection.","ref":"Oban.Engine.html#c:check_meta/3","title":"Oban.Engine.check_meta/3","type":"callback"},{"doc":"Record that a job completed successfully.","ref":"Oban.Engine.html#c:complete_job/2","title":"Oban.Engine.complete_job/2","type":"callback"},{"doc":"Transition a job to discarded and record an optional reason that it shouldn't be ran again.","ref":"Oban.Engine.html#c:discard_job/2","title":"Oban.Engine.discard_job/2","type":"callback"},{"doc":"Record an executing job's errors and either retry or discard it, depending on whether it has exhausted its available attempts.","ref":"Oban.Engine.html#c:error_job/3","title":"Oban.Engine.error_job/3","type":"callback"},{"doc":"Fetch available jobs for the given queue, up to configured limits.","ref":"Oban.Engine.html#c:fetch_jobs/3","title":"Oban.Engine.fetch_jobs/3","type":"callback"},{"doc":"Initialize metadata for a queue engine. Queue metadata is used to identify and track subsequent actions such as fetching or staging jobs.","ref":"Oban.Engine.html#c:init/2","title":"Oban.Engine.init/2","type":"callback"},{"doc":"Insert multiple jobs into the database.","ref":"Oban.Engine.html#c:insert_all_jobs/3","title":"Oban.Engine.insert_all_jobs/3","type":"callback"},{"doc":"","ref":"Oban.Engine.html#c:insert_all_jobs/5","title":"Oban.Engine.insert_all_jobs/5","type":"callback"},{"doc":"Insert a job into the database.","ref":"Oban.Engine.html#c:insert_job/3","title":"Oban.Engine.insert_job/3","type":"callback"},{"doc":"","ref":"Oban.Engine.html#c:insert_job/5","title":"Oban.Engine.insert_job/5","type":"callback"},{"doc":"Delete completed, cancelled and discarded jobs.","ref":"Oban.Engine.html#c:prune_jobs/3","title":"Oban.Engine.prune_jobs/3","type":"callback"},{"doc":"Store the given key/value pair in the engine meta.","ref":"Oban.Engine.html#c:put_meta/4","title":"Oban.Engine.put_meta/4","type":"callback"},{"doc":"Refresh a queue to indicate that it is still alive.","ref":"Oban.Engine.html#c:refresh/2","title":"Oban.Engine.refresh/2","type":"callback"},{"doc":"Mark many jobs as available , adding attempts if already maxed out. Any jobs currently available , executing or scheduled should be ignored.","ref":"Oban.Engine.html#c:retry_all_jobs/2","title":"Oban.Engine.retry_all_jobs/2","type":"callback"},{"doc":"Mark a job as available , adding attempts if already maxed out. If the job is currently available , executing or scheduled it should be ignored.","ref":"Oban.Engine.html#c:retry_job/2","title":"Oban.Engine.retry_job/2","type":"callback"},{"doc":"Prepare a queue engine for shutdown. The queue process is expected to stop processing new jobs after shutdown starts, though it may continue executing jobs that are already running.","ref":"Oban.Engine.html#c:shutdown/2","title":"Oban.Engine.shutdown/2","type":"callback"},{"doc":"Reschedule an executing job to run some number of seconds in the future.","ref":"Oban.Engine.html#c:snooze_job/3","title":"Oban.Engine.snooze_job/3","type":"callback"},{"doc":"Transition scheduled or retryable jobs to available prior to execution.","ref":"Oban.Engine.html#c:stage_jobs/3","title":"Oban.Engine.stage_jobs/3","type":"callback"},{"doc":"","ref":"Oban.Engine.html#t:conf/0","title":"Oban.Engine.conf/0","type":"type"},{"doc":"","ref":"Oban.Engine.html#t:job/0","title":"Oban.Engine.job/0","type":"type"},{"doc":"","ref":"Oban.Engine.html#t:meta/0","title":"Oban.Engine.meta/0","type":"type"},{"doc":"","ref":"Oban.Engine.html#t:opts/0","title":"Oban.Engine.opts/0","type":"type"},{"doc":"","ref":"Oban.Engine.html#t:queryable/0","title":"Oban.Engine.queryable/0","type":"type"},{"doc":"","ref":"Oban.Engine.html#t:running/0","title":"Oban.Engine.running/0","type":"type"},{"doc":"","ref":"Oban.Engine.html#t:seconds/0","title":"Oban.Engine.seconds/0","type":"type"},{"doc":"The Notifier coordinates listening for and publishing notifications for events in predefined channels. Every Oban supervision tree contains a notifier process, registered as Oban.Notifier , which must be an implementation of the Oban.Notifier behaviour. The default implementation is uses the LISTEN/NOTIFY operations built into Postgres. All incoming notifications are relayed through the notifier to other processes. Channels Internally, Oban uses a variety of predefined channels with distinct responsibilities: insert — as jobs are inserted into the database an event is published on the insert channel. Processes such as queue producers use this as a signal to dispatch new jobs. leader — messages regarding node leadership exchanged between peers signal — instructions to take action, such as scale a queue or kill a running job, are sent through the signal channel gossip — arbitrary communication for coordination between nodes stager — messages regarding job staging, e.g. notifying queues that jobs are ready for execution Examples Broadcasting after a job is completed: defmodule MyApp.Worker do use Oban.Worker @impl Oban.Worker def perform ( job ) do :ok = MyApp . do_work ( job . args ) Oban.Notifier . notify ( Oban , :my_app_jobs , %{ complete : job . id } ) :ok end end Listening for job complete events from another process: def insert_and_listen ( args ) do :ok = Oban.Notifier . listen ( [ :my_app_jobs ] ) { :ok , %{ id : job_id } = job } = args |&gt; MyApp.Worker . new ( ) |&gt; Oban . insert ( ) receive do { :notification , :my_app_jobs , %{ &quot;complete&quot; =&gt; ^ job_id } } -&gt; IO . puts ( &quot;Other job complete!&quot; ) after 30_000 -&gt; IO . puts ( &quot;Other job didn&#39;t finish in 30 seconds!&quot; ) end end","ref":"Oban.Notifier.html","title":"Oban.Notifier","type":"behaviour"},{"doc":"Register the current process to receive relayed messages for the provided channels. All messages are received as JSON and decoded before they are relayed to registered processes. Each registered process receives a three element notification tuple in the following format: { :notification , channel :: channel ( ) , decoded :: map ( ) } Example Register to listen for all :gossip channel messages: Oban.Notifier . listen ( :gossip ) Listen for messages on multiple channels: Oban.Notifier . listen ( [ :gossip , :insert , :leader , :signal , :stager ] ) Listen for messages when using a custom Oban name: Oban.Notifier . listen ( MyApp.MyOban , [ :gossip , :signal ] )","ref":"Oban.Notifier.html#listen/2","title":"Oban.Notifier.listen/2","type":"function"},{"doc":"Register the current process to receive messages from one or more channels.","ref":"Oban.Notifier.html#c:listen/2","title":"Oban.Notifier.listen/2","type":"callback"},{"doc":"Broadcast a notification to listeners on all nodes. Notifications are scoped to the configured prefix . For example, if there are instances running with the public and private prefixes, a notification published in the public prefix won't be picked up by processes listening with the private prefix. Using notify/3 with a config is soft deprecated. Use a server as the first argument instead Example Broadcast a gossip message: Oban.Notifier . notify ( :gossip , %{ message : &quot;hi!&quot; } )","ref":"Oban.Notifier.html#notify/3","title":"Oban.Notifier.notify/3","type":"function"},{"doc":"Broadcast a notification to all subscribers of a channel.","ref":"Oban.Notifier.html#c:notify/3","title":"Oban.Notifier.notify/3","type":"callback"},{"doc":"Starts a notifier instance.","ref":"Oban.Notifier.html#c:start_link/1","title":"Oban.Notifier.start_link/1","type":"callback"},{"doc":"Unregister the current process from receiving relayed messages on provided channels. Example Stop listening for messages on the :gossip channel: Oban.Notifier . unlisten ( [ :gossip ] ) Stop listening for messages when using a custom Oban name: Oban.Notifier . unlisten ( MyApp.MyOban , [ :gossip ] )","ref":"Oban.Notifier.html#unlisten/2","title":"Oban.Notifier.unlisten/2","type":"function"},{"doc":"Unregister current process from channels.","ref":"Oban.Notifier.html#c:unlisten/2","title":"Oban.Notifier.unlisten/2","type":"callback"},{"doc":"","ref":"Oban.Notifier.html#t:channel/0","title":"Oban.Notifier.channel/0","type":"type"},{"doc":"","ref":"Oban.Notifier.html#t:option/0","title":"Oban.Notifier.option/0","type":"type"},{"doc":"","ref":"Oban.Notifier.html#t:server/0","title":"Oban.Notifier.server/0","type":"type"},{"doc":"The Peer module maintains leadership for a particular Oban instance within a cluster. Leadership is used by plugins, primarily, to prevent duplicate work accross nodes. For example, only the leader's Cron plugin will try inserting new jobs. You can use peer leadership to extend Oban with custom plugins, or even within your own application. Note a few important details about how peer leadership operates: Each peer checks for leadership at a 30 second interval. When the leader exits it broadcasts a message to all other peers to encourage another one to assume leadership. Each Oban instance supervises a distinct Oban.Peer instance. That means that with multiple Oban instances on the same node one instance may be the leader, while the others aren't. Without leadership, global plugins (Cron, Lifeline, Stager, etc.), will not run on any node. Available Peer Implementations There are two built-in peering modules: Oban.Peers.Postgres — uses table-based leadership through the oban_peers table and works in any environment, with or without clustering. Only one node (per instance name) will have a row in the peers table, that node is the leader. This is the default. Oban.Peers.Global — coordinates global locks through distributed Erlang, requires distributed Erlang. Examples Check leadership for the default Oban instance: Oban.Peer . leader? ( ) # =&gt; true That is identical to using the name Oban : Oban.Peer . leader? ( Oban ) # =&gt; true Check leadership for a couple of instances: Oban.Peer . leader? ( Oban.A ) # =&gt; true Oban.Peer . leader? ( Oban.B ) # =&gt; false","ref":"Oban.Peer.html","title":"Oban.Peer","type":"behaviour"},{"doc":"Check whether the current peer instance leads the cluster.","ref":"Oban.Peer.html#c:leader?/1","title":"Oban.Peer.leader?/1","type":"callback"},{"doc":"Check whether the current instance leads the cluster. Example Check leadership for the default Oban instance: Oban.Peer . leader? ( ) # =&gt; true Check leadership for an alternate instance named Oban.Private : Oban.Peer . leader? ( Oban.Private ) # =&gt; true","ref":"Oban.Peer.html#leader?/2","title":"Oban.Peer.leader?/2","type":"function"},{"doc":"Starts a peer instance.","ref":"Oban.Peer.html#c:start_link/1","title":"Oban.Peer.start_link/1","type":"callback"},{"doc":"","ref":"Oban.Peer.html#t:option/0","title":"Oban.Peer.option/0","type":"type"},{"doc":"Defines a shared behaviour for Oban plugins. In addition to implementing the Plugin behaviour, all plugins must be a GenServer , Agent , or another OTP compliant module. Example Defining a basic plugin that satisfies the minimum behaviour: defmodule MyPlugin do @behaviour Oban.Plugin use GenServer @impl Oban.Plugin def start_link ( opts ) do GenServer . start_link ( __MODULE__ , opts , name : opts [ :name ] ) end @impl Oban.Plugin def validate ( opts ) do if is_atom ( opts [ :mode ] ) :ok else { :error , &quot;expected opts to have a :mode key&quot; } end end @impl GenServer def init ( opts ) do case validate ( opts ) do :ok -&gt; { :ok , opts } { :error , reason } -&gt; { :stop , reason } end end end","ref":"Oban.Plugin.html","title":"Oban.Plugin","type":"behaviour"},{"doc":"Starts a Plugin process linked to the current process. Plugins are typically started as part of an Oban supervision tree and will receive the current configuration as :conf , along with a :name and any other provided options.","ref":"Oban.Plugin.html#c:start_link/1","title":"Oban.Plugin.start_link/1","type":"callback"},{"doc":"Validate the structure, presence, or values of keyword options.","ref":"Oban.Plugin.html#c:validate/1","title":"Oban.Plugin.validate/1","type":"callback"},{"doc":"","ref":"Oban.Plugin.html#t:option/0","title":"Oban.Plugin.option/0","type":"type"},{"doc":"Local process storage for Oban instances.","ref":"Oban.Registry.html","title":"Oban.Registry","type":"module"},{"doc":"Fetch the config for an Oban supervisor instance. Example Get the default instance config: Oban.Registry . config ( Oban ) Get config for a custom named instance: Oban.Registry . config ( MyApp.Oban )","ref":"Oban.Registry.html#config/1","title":"Oban.Registry.config/1","type":"function"},{"doc":"Find the {pid, value} pair for a registered Oban process. Example Get the default instance config: Oban.Registry . lookup ( Oban ) Get a supervised module's pid: Oban.Registry . lookup ( Oban , Oban.Notifier )","ref":"Oban.Registry.html#lookup/2","title":"Oban.Registry.lookup/2","type":"function"},{"doc":"Build a via tuple suitable for calls to a supervised Oban process. Example For an Oban supervisor: Oban.Registry . via ( Oban ) For a supervised module: Oban.Registry . via ( Oban , Oban.Notifier ) For a plugin: Oban.Registry . via ( Oban , { :plugin , Oban.Plugins.Cron } )","ref":"Oban.Registry.html#via/3","title":"Oban.Registry.via/3","type":"function"},{"doc":"Returns the pid of a supervised Oban process, or nil if the process can't be found. Example Get the Oban supervisor's pid: Oban.Registry . whereis ( Oban ) Get a supervised module's pid: Oban.Registry . whereis ( Oban , Oban.Notifier ) Get the pid for a plugin: Oban.Registry . whereis ( Oban , { :plugin , MyApp.Oban.Plugin } ) Get the pid for a queue's producer: Oban.Registry . whereis ( Oban , { :producer , &quot;default&quot; } )","ref":"Oban.Registry.html#whereis/2","title":"Oban.Registry.whereis/2","type":"function"},{"doc":"","ref":"Oban.Registry.html#t:key/0","title":"Oban.Registry.key/0","type":"type"},{"doc":"","ref":"Oban.Registry.html#t:role/0","title":"Oban.Registry.role/0","type":"type"},{"doc":"","ref":"Oban.Registry.html#t:value/0","title":"Oban.Registry.value/0","type":"type"},{"doc":"Wrappers around Ecto.Repo and Ecto.Adapters.SQL callbacks. Each function resolves the correct repo instance and sets options such as prefix and log according to Oban.Config . Meant for Extending Oban These functions should only be used when working with a repo inside engines, plugins, or other extensions for Oban. Favor using your application's repo directly when querying Oban.Job from your workers. Examples The first argument for every function must be an Oban.Config struct. Many functions pass configuration around as a conf key, and it can always be fetched with Oban.config/1 . This demonstrates fetching the default instance config and querying all jobs: Oban |&gt; Oban . config ( ) |&gt; Oban.Repo . all ( Oban.Job )","ref":"Oban.Repo.html","title":"Oban.Repo","type":"module"},{"doc":"Wraps Ecto.Repo.aggregate/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#aggregate/4","title":"Oban.Repo.aggregate/4","type":"function"},{"doc":"Wraps Ecto.Repo.all/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#all/3","title":"Oban.Repo.all/3","type":"function"},{"doc":"Wraps Ecto.Repo.checkout/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#checkout/3","title":"Oban.Repo.checkout/3","type":"function"},{"doc":"Wraps Ecto.Repo.config/0 with an additional Oban.Config argument.","ref":"Oban.Repo.html#config/1","title":"Oban.Repo.config/1","type":"function"},{"doc":"The default values extracted from Oban.Config for use in all queries with options.","ref":"Oban.Repo.html#default_options/1","title":"Oban.Repo.default_options/1","type":"function"},{"doc":"Wraps Ecto.Repo.default_options/1 with an additional Oban.Config argument.","ref":"Oban.Repo.html#default_options/2","title":"Oban.Repo.default_options/2","type":"function"},{"doc":"Wraps Ecto.Repo.delete/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#delete/3","title":"Oban.Repo.delete/3","type":"function"},{"doc":"Wraps Ecto.Repo.delete!/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#delete!/3","title":"Oban.Repo.delete!/3","type":"function"},{"doc":"Wraps Ecto.Repo.delete_all/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#delete_all/3","title":"Oban.Repo.delete_all/3","type":"function"},{"doc":"Wraps Ecto.Repo.exists?/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#exists?/3","title":"Oban.Repo.exists?/3","type":"function"},{"doc":"Wraps Ecto.Repo.get/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#get/4","title":"Oban.Repo.get/4","type":"function"},{"doc":"Wraps Ecto.Repo.get!/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#get!/4","title":"Oban.Repo.get!/4","type":"function"},{"doc":"Wraps Ecto.Repo.get_by/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#get_by/4","title":"Oban.Repo.get_by/4","type":"function"},{"doc":"Wraps Ecto.Repo.get_by!/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#get_by!/4","title":"Oban.Repo.get_by!/4","type":"function"},{"doc":"Wraps Ecto.Repo.get_dynamic_repo/0 with an additional Oban.Config argument.","ref":"Oban.Repo.html#get_dynamic_repo/1","title":"Oban.Repo.get_dynamic_repo/1","type":"function"},{"doc":"Wraps Ecto.Repo.in_transaction?/0 with an additional Oban.Config argument.","ref":"Oban.Repo.html#in_transaction?/1","title":"Oban.Repo.in_transaction?/1","type":"function"},{"doc":"Wraps Ecto.Repo.insert/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#insert/3","title":"Oban.Repo.insert/3","type":"function"},{"doc":"Wraps Ecto.Repo.insert!/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#insert!/3","title":"Oban.Repo.insert!/3","type":"function"},{"doc":"Wraps Ecto.Repo.insert_all/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#insert_all/4","title":"Oban.Repo.insert_all/4","type":"function"},{"doc":"Wraps Ecto.Repo.insert_or_update/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#insert_or_update/3","title":"Oban.Repo.insert_or_update/3","type":"function"},{"doc":"Wraps Ecto.Repo.insert_or_update!/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#insert_or_update!/3","title":"Oban.Repo.insert_or_update!/3","type":"function"},{"doc":"Wraps Ecto.Repo.load/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#load/3","title":"Oban.Repo.load/3","type":"function"},{"doc":"Wraps Ecto.Repo.one/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#one/3","title":"Oban.Repo.one/3","type":"function"},{"doc":"Wraps Ecto.Repo.one!/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#one!/3","title":"Oban.Repo.one!/3","type":"function"},{"doc":"Wraps Ecto.Repo.preload/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#preload/4","title":"Oban.Repo.preload/4","type":"function"},{"doc":"Wraps Ecto.Repo.put_dynamic_repo/1 with an additional Oban.Config argument.","ref":"Oban.Repo.html#put_dynamic_repo/2","title":"Oban.Repo.put_dynamic_repo/2","type":"function"},{"doc":"Wraps Ecto.Adapters.SQL.Repo.query/4 with an added Oban.Config argument.","ref":"Oban.Repo.html#query/4","title":"Oban.Repo.query/4","type":"function"},{"doc":"Wraps Ecto.Repo.reload/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#reload/3","title":"Oban.Repo.reload/3","type":"function"},{"doc":"Wraps Ecto.Repo.reload!/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#reload!/3","title":"Oban.Repo.reload!/3","type":"function"},{"doc":"Wraps Ecto.Repo.rollback/1 with an additional Oban.Config argument.","ref":"Oban.Repo.html#rollback/2","title":"Oban.Repo.rollback/2","type":"function"},{"doc":"Wraps Ecto.Repo.stream/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#stream/3","title":"Oban.Repo.stream/3","type":"function"},{"doc":"Wraps Ecto.Adapters.SQL.Repo.to_sql/2 with an added Oban.Config argument.","ref":"Oban.Repo.html#to_sql/3","title":"Oban.Repo.to_sql/3","type":"function"},{"doc":"Wraps Ecto.Repo.transaction/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#transaction/3","title":"Oban.Repo.transaction/3","type":"function"},{"doc":"Wraps Ecto.Repo.update/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#update/3","title":"Oban.Repo.update/3","type":"function"},{"doc":"Wraps Ecto.Repo.update!/2 with an additional Oban.Config argument.","ref":"Oban.Repo.html#update!/3","title":"Oban.Repo.update!/3","type":"function"},{"doc":"Wraps Ecto.Repo.update_all/3 with an additional Oban.Config argument.","ref":"Oban.Repo.html#update_all/4","title":"Oban.Repo.update_all/4","type":"function"},{"doc":"A PG/PG2 based notifier implementation that runs with Distributed Erlang. Out of the box, Oban uses PostgreSQL's LISTEN/NOTIFY for PubSub. For most applications, that is fine, but Postgres-based PubSub isn't sufficient in some circumstances. In particular, Postgres notifications won't work when your application connects through PGbouncer in transaction or statement mode. Note: You must be using Distributed Erlang to use the PG notifier. Usage Specify the PG notifier in your Oban configuration: config :my_app , Oban , notifier : Oban.Notifiers.PG , ... Implementation Notes The notifier will use pg if available (OTP 23+) or fall back to pg2 for older OTP releases. Like the Postgres implementation, notifications are namespaced by prefix . For compatibility, message payloads are always serialized to JSON before broadcast and deserialized before relay to local processes. Migrating from Oban.Notifiers.Postgres After switching from Oban.Notifiers.Postgres , you may remove the unused oban_notify trigger. Use the following migration to drop the trigger while retaining the oban_jobs_notify function: defmodule MyApp.Repo.Migrations.DropObanJobsNotifyTrigger do use Ecto.Migration def change do execute ( &quot;DROP TRIGGER IF EXISTS oban_notify ON public.oban_jobs&quot; , &quot;CREATE TRIGGER oban_notify AFTER INSERT ON public.oban_jobs FOR EACH ROW EXECUTE PROCEDURE public.oban_jobs_notify()&quot; ) end end","ref":"Oban.Notifiers.PG.html","title":"Oban.Notifiers.PG","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Notifiers.PG.html#child_spec/1","title":"Oban.Notifiers.PG.child_spec/1","type":"function"},{"doc":"A Postgres Listen/Notify based Notifier. Usage Specify the Postgres notifier in your Oban configuration: config :my_app , Oban , notifier : Oban.Notifiers.Postgres Caveats The notifications system is built on PostgreSQL's LISTEN/NOTIFY functionality. Notifications are only delivered after a transaction completes and are de-duplicated before publishing. Typically, applications run Ecto in sandbox mode while testing, but sandbox mode wraps each test in a separate transaction that's rolled back after the test completes. That means the transaction is never committed, which prevents delivering any notifications. To test using notifications you must run Ecto without sandbox mode enabled, or use Oban.Notifiers.PG instead.","ref":"Oban.Notifiers.Postgres.html","title":"Oban.Notifiers.Postgres","type":"module"},{"doc":"Register current process to receive messages from some channels","ref":"Oban.Notifiers.Postgres.html#listen/2","title":"Oban.Notifiers.Postgres.listen/2","type":"function"},{"doc":"Start the notifier.","ref":"Oban.Notifiers.Postgres.html#start_link/1","title":"Oban.Notifiers.Postgres.start_link/1","type":"function"},{"doc":"Unregister current process from channels","ref":"Oban.Notifiers.Postgres.html#unlisten/2","title":"Oban.Notifiers.Postgres.unlisten/2","type":"function"},{"doc":"A cluster based peer that coordinates through a distributed registry. Leadership is coordinated through global locks. It requires a functional distributed Erlang cluster, without one global plugins (Cron, Lifeline, Stager, etc.) will not function correctly. Usage Specify the Global peer in your Oban configuration. config :my_app , Oban , peer : Oban.Peers.Global , ...","ref":"Oban.Peers.Global.html","title":"Oban.Peers.Global","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Peers.Global.html#child_spec/1","title":"Oban.Peers.Global.child_spec/1","type":"function"},{"doc":"A Postgres based peer that coordinates centrally through a database table. Postgres peers don't require clustering through distributed Erlang or any other interconnectivity between nodes. Leadership is coordinated through the oban_peers table in your database. With a standard Oban config the oban_peers table will only have one row, and that node is the leader. Applications that run multiple Oban instances will have one row per instance. For example, an umbrella application that runs Oban.A and Oban.B will have two rows in oban_peers . Usage Specify the Postgres peer in your Oban configuration. config :my_app , Oban , peer : Oban.Peers.Postgres , ...","ref":"Oban.Peers.Postgres.html","title":"Oban.Peers.Postgres","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Oban.Peers.Postgres.html#child_spec/1","title":"Oban.Peers.Postgres.child_spec/1","type":"function"},{"doc":"The default engine for use with Postgres databases. Usage This is the default engine, no additional configuration is necessary: Oban . start_link ( repo : MyApp.Repo , queues : [ default : 10 ] )","ref":"Oban.Engines.Basic.html","title":"Oban.Engines.Basic","type":"module"},{"doc":"A testing-specific engine that's used when Oban's started with testing: :inline . Usage This is meant for testing and shouldn't be configured directly: Oban . start_link ( repo : MyApp.Repo , testing : :inline )","ref":"Oban.Engines.Inline.html","title":"Oban.Engines.Inline","type":"module"},{"doc":"An engine for running Oban with SQLite3. Usage Start an Oban instance using the Lite engine: Oban . start_link ( engine : Oban.Engines.Lite , queues : [ default : 10 ] , repo : MyApp.Repo )","ref":"Oban.Engines.Lite.html","title":"Oban.Engines.Lite","type":"module"},{"doc":"Wraps unhandled exits and throws that occur during job execution.","ref":"Oban.CrashError.html","title":"Oban.CrashError","type":"exception"},{"doc":"Wraps the reason returned by {:error, reason} , {:cancel, reason} , or {:discard, reason} in a proper exception. The original return tuple is available in the :reason key.","ref":"Oban.PerformError.html","title":"Oban.PerformError","type":"exception"},{"doc":"Returned when a job is terminated early due to a custom timeout.","ref":"Oban.TimeoutError.html","title":"Oban.TimeoutError","type":"exception"},{"doc":"🌟 Looking for changes to Web or Pro? Check the Oban.Pro Changelog or the Oban.Web Changelog . 🌟","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Oban uses notifications across most core functionality, from job staging to cancellation. Some notifications, such as gossip, contain massive redundancy that compresses nicely. For example, this table breaks down the compression ratios for a fairly standard gossip payload containing data from ten queues: Mode Bytes % of Original Original 4720 100% Gzip 307 7% Encode 64 412 9% Minimizing notification payloads is especially important for Postgres because it applies an 8kb limit to all messages. Now all pub/sub notifications are compressed automatically, with a safety mechanism for compatibility with external notifiers, namely Postgres triggers.","ref":"changelog.html#notification-compression","title":"Changelog - 🗜️ Notification Compression","type":"extras"},{"doc":"There has been an ongoing issue with systems recording a job attempt twice, when it only executed once. While that sounds minor, it could break an entire queue when the attempt exceeded max attempts because it would violate a database constraint. Apparently, the Postgres planner may choose to generate a plan that executes a nested loop over the LIMITing subquery, causing more UPDATEs than LIMIT. That could cause unexpected updates, including attempts &gt; max attempts in some cases. The solution is to use a CTE as an &quot;optimization fence&quot; that forces Postgres _not to optimize the query. We also worked in a few additional query improvements: Use an index only scan for job staging to safely handle tables with millions of scheduled jobs. Remove unnecessary row locking from staging and pruning queries.","ref":"changelog.html#query-improvements","title":"Changelog - 🗃️ Query Improvements","type":"extras"},{"doc":"We're pleased to share improvements in Oban's SQLite integration. A few SQLite pioneers identified pruning and staging compatibility bugs, and instead of simply patching around the issues with conditional logic, we tackled them with new engine callbacks: stage_jobs/3 and prune_jobs/3 . The result is safer, optimized queries for each specific database. Introducing new engine callbacks with database-specific queries paves the way for working with other databases. There's even an open issue for MySQL support ...","ref":"changelog.html#new-engine-callbacks-for-sql-compatibility","title":"Changelog - 🪶 New Engine Callbacks for SQL Compatibility","type":"extras"},{"doc":"Enhancements [Oban] Use DynamicSupervisor to supervise queues for optimal shutdown Standard supervisors shut down in a fixed order, which could make shutting down queues with active jobs and a lengthy grace period very slow. This switches to a DynamicSupervisor for queue supervision so queues can shut down simultaneously while still respecting the grace period. [Executor] Retry acking infinitely after job execution After jobs execute the producer must record their status in the database. Previously, if acking failed due to a connection error after 10 retries it would orphan the job. Now, acking retries infinitely (with backoff) until the function succeeds. The result is stronger execution guarantees with backpressure during periods of database fragility. [Oban] Accept a Job struct as well as a job id for cancel_job/1 and retry_job/1 Now it's possible to write Oban.cancel_job(job) directly, rather than Oban.cancel_job(job.id) . [Worker] Allow snoozing jobs for zero seconds. Returning {:snooze, 0} immediately reschedules a job without any delay. [Notifier] Accept arbitrary channel names for notifications, e.g. &quot;my-channel&quot; [Telemetry] Add 'detach_default_logger/0' to programmatically disable an attached logger. [Testing] Avoid unnecessary query for &quot;happy path&quot; assertion errors in assert_enqueued/2 [Testing] Inspect charlists as lists in testing assertions Args frequently contain lists of integers like [123] , which was curiously displayed as '{' . Bug Fixes [Executor] Correctly raise &quot;unknown worker&quot; errors. Unknown workers triggered an unknown case error rather than the appropriate &quot;unknown worker&quot; runtime error. [Testing] Allow assert_enqueued with a scheduled_at time for available jobs The use of Job.new to normalize query fields would change assertions with a &quot;scheduled at&quot; date to _only check scheduled, never &quot;available&quot; [Telemetry] Remove :worker from engine and plugin query meta. The worker isn't part of any query indexes and prevents optimal index usage. [Job] Correct priority type to cover default of 0 For changes prior to v2.15 see the v2.14 docs.","ref":"changelog.html#v2-15-0-2023-04-13","title":"Changelog - v2.15.0 — 2023-04-13","type":"extras"},{"doc":"Oban is published on Hex . Add it to your list of dependencies in mix.exs : # mix.exs def deps do [ { :oban , &quot;~&gt; 2.14&quot; } ] end Then run mix deps.get to install Oban and its dependencies, including Ecto and Jason . You'll optionally need to include either Postgrex for use with Postgres, or [EctoSQLite3][sqlite] for SQLite3. After the packages are installed you must create a database migration to add the oban_jobs table to your database: mix ecto.gen.migration add_oban_jobs_table Open the generated migration in your editor and call the up and down functions on Oban.Migration : defmodule MyApp.Repo.Migrations.AddObanJobsTable do use Ecto.Migration def up do Oban.Migration . up ( version : 11 ) end # We specify `version: 1` in `down`, ensuring that we&#39;ll roll all the way back down if # necessary, regardless of which version we&#39;ve migrated `up` to. def down do Oban.Migration . down ( version : 1 ) end end This will run all of Oban's versioned migrations for your database. Migrations between versions are idempotent and rarely† change after a release. As new versions are released you may need to run additional migrations. † The only exception is the removal of oban_beats . That table is no longer created or modified in any migrations Now, run the migration to create the table: mix ecto.migrate Before you can run an Oban instance you must provide some configuration. Set some base configuration within config.exs : # config/config.exs config :my_app , Oban , repo : MyApp.Repo , plugins : [ Oban.Plugins.Pruner ] , queues : [ default : 10 ] To prevent Oban from running jobs and plugins during test runs, enable :testing mode in test.exs : # config/test.exs config :my_app , Oban , testing : :inline Oban instances are isolated supervision trees and must be included in your application's supervisor to run. Use the application configuration you've just set and include Oban in the list of supervised children: # lib/my_app/application.ex def start ( _type , _args ) do children = [ MyApp.Repo , { Oban , Application . fetch_env! ( :my_app , Oban ) } ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end Finally, verify that Oban is configured and running properly. Within a new iex -S mix session: iex(1)&gt; Oban . config ( ) #=&gt; %Oban.Config{repo: MyApp.Repo} You're all set! Get started creating jobs and configuring queues in Usage , or head to the testing guide to learn how to test with Oban.","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"","ref":"troubleshooting.html","title":"Troubleshooting","type":"extras"},{"doc":"Using PgBouncer's &quot;Transaction Pooling&quot; setup disables all of PostgreSQL's LISTEN and NOTIFY activity. Some functionality, such as triggering job execution, scaling queues, canceling jobs, etc. rely on those notifications. There are several options available to ensure functional notifications: Switch to the Oban.Notifiers.PG notifier. This alternative notifier relies on Distributed Erlang and exchanges messages within a cluster. The only drawback to the PG notifier is that it doesn't trigger job insertion events. Switch PgBouncer to &quot;Session Pooling&quot;. Session pooling isn't as resource efficient as transaction pooling, but it retains all Postgres functionality. Use a dedicated Repo that connects directly to the database, bypassing PgBouncer . If none of those options work, the Stager will switch to local polling mode to ensure that queues keep processing jobs.","ref":"troubleshooting.html#no-notifications-with-pgbouncer","title":"Troubleshooting - No Notifications with PgBouncer","type":"extras"},{"doc":"Without a version comment on the oban_jobs table, it will rerun all of the migrations. This can happen when comments are stripped when restoring from a backup, most commonly during a transition from one database to another. The fix is to set the latest migrated version as a comment. To start, search through your previous migrations and find the last time you ran an Oban migration. Once you've found the latest version, e.g. version: 10 , then you can set that as a comment on the oban_jobs table: COMMENT ON TABLE public.oban_jobs IS '10'&quot; Once the comment is in place only the migrations from that version onward will run.","ref":"troubleshooting.html#unexpectedly-re-running-all-migrations","title":"Troubleshooting - Unexpectedly Re-running All Migrations","type":"extras"},{"doc":"Elixir and Erlang Versions If your app crashes on launch, be sure to confirm you are running the correct version of Elixir and Erlang ( view requirements ). If using the hashnuke/elixir buildpack, you can update the elixir_buildpack.config file in your application's root directory to something like: # Elixir version elixir_version = 1.13 . 0 # Erlang version erlang_version = 24.2 Available Erlang versions are available here . Database Connections Make sure that you have enough available database connections when running on Heroku. Oban uses a database connection in order to listen for Pub/Sub notifications. This is in addition to your Ecto Repo pool_size setting. Heroku's Hobby tier Postgres plans have a maximum of 20 connections, so if you're using one of those plan accordingly.","ref":"troubleshooting.html#heroku","title":"Troubleshooting - Heroku","type":"extras"},{"doc":"While having the same Oban configuration for every environment might be fine, there are certainly times you might want to make changes for a specific environment. For example, you may want to increase or decrease a queue's concurrency.","ref":"release_configuration.html","title":"Release Configuration","type":"extras"},{"doc":"If you are using Elixir Releases, this is straight forward to do using Config Providers : defmodule MyApp.ConfigProvider do @moduledoc &quot;&quot;&quot; Provide release configuration for Oban Queue Concurrency &quot;&quot;&quot; @behaviour Config.Provider def init ( path ) when is_binary ( path ) , do : path def load ( config , path ) do case parse_json ( path ) do nil -&gt; config queues -&gt; Config.Reader . merge ( config , ingestion : [ { Oban , [ queues : queues ] } ] ) end end defp parse_json ( path ) do { :ok , _ } = Application . ensure_all_started ( :jason ) if File . exists? ( path ) do path |&gt; File . read! ( ) |&gt; Jason . decode! ( ) |&gt; Map . fetch! ( &quot;queues&quot; ) |&gt; Keyword . new ( fn { key , value } -&gt; { String . to_atom ( key ) , value } end ) end end end Our config provider ensures that the Jason app is loaded so that we can parse a JSON configuration file. Once the JSON is loaded we must extract the queues map and convert it to a keyword list where all of the keys are atoms. The use of String.to_atom/1 is safe because all of our queues names are already defined. Then you include this in your mix.exs file, where your release is configured: releases : [ umbrella_app : [ version : &quot;0.0.1&quot; , applications : [ child_app : :permanent ] , config_providers : [ { Path.To.ConfigProvider , &quot;/etc/config.json&quot; } ] ] ] Then when you release your app, you ensure that you have a JSON file mounted at whatever path you specified above and that it contains all of your desired queues: {&quot;queues&quot;: {&quot;special&quot;: 1, &quot;default&quot;: 10, &quot;events&quot;: 20}}","ref":"release_configuration.html#using-config-providers","title":"Release Configuration - Using Config Providers","type":"extras"},{"doc":"Oban supports the use of plugins to extend its base functionality. A plugin is any module that begins a process and exposes a start_link/1 function. That means a plugin may be a GenServer , an Agent , a Task , or any other OTP behaviour that manages a process. Realistically you'll want a long lived process to complement Oban's behaviour, which makes a GenServer or GenStateMachine ideal. Upon startup, Oban dynamically injects each plugin into its supervision tree and passes a few base options along with any custom configuration for the plugin. Every plugin receives these base options: :conf — An Oban.Config struct, which contains all of the options provided to Oban.start_link/1 in a validated and normalized form. :name — A unique via tuple scoped to the current supervision tree. The name may be used later to support helper/interface functions.","ref":"writing_plugins.html","title":"Writing Plugins","type":"extras"},{"doc":"Let's look at a tiny example plugin to get a feel for how options are passed in and how they run. Our plugin will periodically generate a table of counts for each queue / state combination and then print it out. It isn't an amazingly useful plugin, but it demonstrates how to handle options, work with the Oban.Config struct, and periodically interact with the oban_jobs table. defmodule MyApp.Plugins.Breakdown do @behaviour Oban.Plugin use GenServer import Ecto.Query , only : [ group_by : 3 , select : 3 ] @impl Oban.Plugin def start_link ( opts ) do name = Keyword . get ( opts , :name , __MODULE__ ) GenServer . start_link ( __MODULE__ , opts , name : name ) end @impl Oban.Plugin def validate ( opts ) do Oban.Plugin . valdate ( opts , { :conf , _ } -&gt; :ok { :name , _ } -&gt; :ok { :interval , _ } -&gt; if is_integer ( interval ) do :ok else { :error , &quot;expected interval to be an integer&quot; } end end ) end @impl GenServer def init ( opts ) do state = Map . new ( opts ) { :ok , schedule_poll ( state ) } end @impl GenServer def handle_info ( :poll , %{ conf : conf } = state ) do breakdown = Oban.Repo . all ( conf , Oban.Job |&gt; group_by ( [ j ] , [ j . queue , j . state ] ) |&gt; select ( [ j ] , { j . queue , j . state , count ( j . id ) } ) ) IO . inspect ( breakdown ) { :noreply , schedule_poll ( state ) } end defp schedule_poll ( %{ interval : interval } ) do Process . send_after ( self ( ) , :poll , interval ) state end end The plugin's start_link/1 function expects a keyword list with :name , :conf , and :interval values. After extracting the :name for process registration, it passes the options through to init/1 . The init function converts the keyword list of options into a map for easier access and then begins a polling loop. Each iteration of the loop will query the oban_jobs table and print out a list of {queue, state, count} tuples like this: [ { &quot;default&quot; , &quot;executing&quot; , 8 } , { &quot;default&quot; , &quot;retryable&quot; , 1 } , { &quot;default&quot; , &quot;completed&quot; , 3114 } , { &quot;default&quot; , &quot;discarded&quot; , 1 } , { &quot;events&quot; , &quot;scheduled&quot; , 3 } , { &quot;events&quot; , &quot;executing&quot; , 21 } , { &quot;events&quot; , &quot;retryable&quot; , 2 } , { &quot;events&quot; , &quot;completed&quot; , 1783 } , { &quot;events&quot; , &quot;discarded&quot; , 1 } , ] Now all that is left is to adding the Breakdown module to Oban's plugin list: config :my_app , Oban , plugins : [ { MyApp.Plugins.Breakdown , interval : :timer . seconds ( 10 ) } ] ... In the configuration we're only providing the :interval value. Oban injects the :name and :conf automatically.","ref":"writing_plugins.html#example-plugin","title":"Writing Plugins - Example Plugin","type":"extras"},{"doc":"Plugins are named dynamically using via tuples, which is an effective way to manage process registration for multiple unique Oban instances. However, it makes writing interface functions for plugins a little more complicated. The solution is to make use of the Oban.Registry for process discovery. Imagine adding a pause interface function to the Breakdown plugin we built above: alias Oban.Registry def pause ( oban_name \\\\ Oban ) do oban_name |&gt; Registry . whereis ( { :plugin , __MODULE__ } ) |&gt; GenServer . call ( :pause ) end The function accepts an oban_name argument with a default of Oban , which is the default name for an Oban supervision tree. It then calls whereis/2 with a {:plugin, plugin_name} tuple and uses the returned pid to call the plugin process. You can then call pause/1 from elsewhere in the application: MyApp.Plugins.Breakdown . pause ( ) # or MyApp.Plugins.Breakdown . pause ( MyApp.OtherOban )","ref":"writing_plugins.html#calling-interface-functions","title":"Writing Plugins - Calling Interface Functions","type":"extras"},{"doc":"Plugins run directly within Oban's supervision tree. A badly behaving plugin, e.g. a plugin that crashes repeatedly, may bring down the entire supervision tree. Be sure that your plugin has safety mechanisms in place to prevent repeated crashes during startup.","ref":"writing_plugins.html#caveats","title":"Writing Plugins - Caveats","type":"extras"},{"doc":"Recursive jobs, like recursive functions, call themselves after they have executed. Except unlike recursive functions, where recursion happens in a tight loop, a recursive job enqueues a new version of itself and may add a slight delay to alleviate pressure on the queue. Recursive jobs are a great way to backfill large amounts of data where a database migration or a mix task may not be suitable. Here are a few reasons that a recursive job may be better suited for backfilling data: Data can't be backfilled with a database migration, it may require talking to an external service A task may fail partway through execution; resuming the task would mean starting over again, or tracking progress manually to resume where the failure occurred A task may be computationally intensive or put heavy pressure on the database A task may run for too long and would be interrupted by code releases or other node restarts A task may interface with an external service and require some rate limiting A job can be used directly for new records and to backfill existing records Let's explore recursive jobs with a use case that builds on several of those reasons.","ref":"recursive-jobs.html","title":"Recursive Jobs","type":"extras"},{"doc":"Consider a worker that queries an external service to determine what timezone a user resides in. The external service has a rate limit and the response time is unpredictable. We have a lot of users in our database missing timezone information, and we need to backfill. Our application has an existing TimezoneWorker that accepts a user's id , makes an external request and then updates the user's timezone. We can modify the worker to handle backfilling by adding a new clause to perform/1 . The new clause explicitly checks for a backfill argument and will enqueue the next job after it executes: defmodule MyApp.Workers.TimezoneWorker do use Oban.Worker import Ecto.Query alias MyApp . { Repo , User } @backfill_delay 1 @impl true def perform ( %{ args : %{ &quot;id&quot; =&gt; id , &quot;backfill&quot; =&gt; true } } ) do with :ok &lt;- perform ( %{ args : %{ &quot;id&quot; =&gt; id } } ) do case fetch_next ( id ) do next_id when is_integer ( next_id ) -&gt; %{ id : next_id , backfill : true } |&gt; new ( schedule_in : @backfill_delay ) |&gt; Oban . insert ( ) nil -&gt; :ok end end end def perform ( %{ args : %{ &quot;id&quot; =&gt; id } } ) do update_timezone ( id ) end defp fetch_next ( current_id ) do User |&gt; where ( [ u ] , is_nil ( u . timezone ) ) |&gt; where ( [ u ] , u . id &gt; ^ current_id ) |&gt; order_by ( asc : :id ) |&gt; limit ( 1 ) |&gt; select ( [ u ] , u . id ) |&gt; Repo . one ( ) end defp update_timezone ( _id ) , do : Enum . random ( [ :ok , { :error , :reason } ] ) end There is a lot happening in the worker module, so let's unpack it a little bit. There are two clauses for perform/1 , the first only matches when a job is marked as &quot;backfill&quot; =&gt; true , the second does the actual work of updating the timezone. The backfill clause checks that the timezone update succeeds and then uses fetch_next/1 to look for the id of the next user without a timezone. When another user needing a backfill is available it enqueues a new backfill job with a one second delay. With the new perform/1 clause in place and our code deployed we can kick off the recursive backfill. Assuming the id of the first user is 1 , you can start the job from an iex console: iex&gt; %{ id : 1 , backfill : true } |&gt; MyApp.Workers.TimezoneWorker . new ( ) |&gt; Oban . insert ( ) Now the jobs will chug along at a steady rate of one per second until the backfill is complete (or something fails). If there are any errors the backfill will pause until the failing job completes: especially useful for jobs relying on flaky external services. Finally, when there aren't any more user's without a timezone, the backfill is complete and recursion will stop.","ref":"recursive-jobs.html#use-case-backfilling-timezone-data","title":"Recursive Jobs - Use Case: Backfilling Timezone Data","type":"extras"},{"doc":"This was a relatively simple example, and hopefully it illustrates the power and flexibility of recursive jobs. Recursive jobs are a general pattern and aren't specific to Oban. In fact, aside from the use Oban.Worker directive there isn't anything specific to Oban in the recipe!","ref":"recursive-jobs.html#building-on-recursive-jobs","title":"Recursive Jobs - Building On Recursive Jobs","type":"extras"},{"doc":"A common variant of recursive jobs are &quot;scheduled jobs&quot;, where the goal is for a job to repeat indefinitely with a fixed amount of time between executions. The part that makes it &quot;reliable&quot; is the guarantee that we'll keep retrying the job's business logic when the job retries, but we'll only schedule the next occurrence once . In order to achieve this guarantee we'll make use of the perform function to receive a complete Oban.Job struct. Time for illustrative example!","ref":"reliable-scheduling.html","title":"Reliable Scheduled Jobs","type":"extras"},{"doc":"When a new user signs up to use our site we need to start sending them daily digest emails. We want to deliver the emails around the same time a user signed up, repeating every 24 hours. It is important that we don't spam them with duplicate emails, so we ensure that the next email is only scheduled on our first attempt. defmodule MyApp.Workers.ScheduledWorker do use Oban.Worker , queue : :scheduled , max_attempts : 10 alias MyApp.Mailer @one_day 60 * 60 * 24 @impl true def perform ( %{ args : %{ &quot;email&quot; =&gt; email } = args , attempt : 1 } ) do args |&gt; new ( schedule_in : @one_day ) |&gt; Oban . insert! ( ) Mailer . deliver_email ( email ) end def perform ( %{ args : %{ &quot;email&quot; =&gt; email } } ) do Mailer . deliver_email ( email ) end end You'll notice that the first perform/1 clause only matches a job struct on the first attempt. When it matches, the first clause schedules the next iteration immediately, before attempting to deliver the email. Any subsequent retries fall through to the second perform/1 clause, which only attempts to deliver the email again. Combined, the clauses get us close to at-most-once semantics for scheduling , and at-least-once semantics for delivery .","ref":"reliable-scheduling.html#use-case-delivering-daily-digest-emails","title":"Reliable Scheduled Jobs - Use Case: Delivering Daily Digest Emails","type":"extras"},{"doc":"Delivering around the same time using cron-style scheduling would need extra book-keeping to check when a user signed up, and then only deliver to those users that signed up within that window of time. The recursive scheduling approach is more accurate and entirely self contained—when and if the digest interval changes the scheduling will pick it up automatically once our code deploys. An extensive discussion on the Oban issue tracker prompted this example along with the underlying feature that made it possible.","ref":"reliable-scheduling.html#more-flexible-than-cron-scheduling","title":"Reliable Scheduled Jobs - More Flexible Than CRON Scheduling","type":"extras"},{"doc":"If you use the schedule_in or scheduled_at options with a value that will resolve to the very-near-future, for example: # 1 second from now %{ } |&gt; new ( schedule_in : 1 ) |&gt; Oban . insert ( ) # 500 milliseconds from now very_soon = DateTime . utc_now ( ) |&gt; DateTime . add ( 500 , :millisecond ) %{ } |&gt; new ( scheduled_at : very_soon ) |&gt; Oban . insert ( ) your workers may not be aware of/attempt to perform the job until the next tick as specific by the Oban Stager :interval option. By default this is set to 1_000ms . Be aware: Configuring the :interval option below the recommended default can have a considerable impact on database performance! It is not advised to lower this value and should only be done as a last resort after considering other ways to achieve your desired outcome.","ref":"reliable-scheduling.html#considerations-for-scheduling-jobs-in-the-very-near-future","title":"Reliable Scheduled Jobs - Considerations for Scheduling Jobs in the Very-Near-Future","type":"extras"},{"doc":"Most applications provide some way to generate an artifact—something that may take the server a long time to accomplish. If it takes several minutes to render a video, crunch some numbers or generate an export, users may be left wondering whether your application is working. Providing periodic updates to end users assures them that the work is being done and keeps the application feeling responsive. Reporting progress is something that any background job processor with unlimited execution time can do! Naturally, we'll look at an example built on Oban.","ref":"reporting-progress.html","title":"Reporting Job Progress","type":"extras"},{"doc":"Users of our site can export a zip of all the files they have uploaded. A zip file (no, not a tar, our users don't have neck-beards) is generated on the fly, when the user requests it. Lazily generating archives is great for our server's utilization, but it means that users may wait a while when there are many files. Fortunately, we know how many files will be included in the zip and we can use that information to send progress reports! We will compute the archive's percent complete as each file is added and push a message to the user. Before We Start In the forum question that prompted this guide the work was done externally by a port process. Working with ports is well outside the scope of this guide, so I've modified it for the sake of simplicity. The result is slightly contrived as it puts both processes within the same module, which isn't necessary if the only goal is to broadcast progress. This guide is ultimately about coordinating processes to report progress from a background job, so that's what we'll focus on (everything else will be rather hand-wavy ).","ref":"reporting-progress.html#use-case-exporting-a-large-zip-file","title":"Reporting Job Progress - Use Case: Exporting a Large Zip File","type":"extras"},{"doc":"Our worker, the creatively titled ZippingWorker , handles both building the archive and reporting progress to the client. Showing the entire module at once felt distracting, so we'll start with only the module definition and the perform/1 function: defmodule MyApp.Workers.ZippingWorker do use Oban.Worker , queue : :exports , max_attempts : 1 alias MyApp . { Endpoint , Zipper } def perform ( % _ { args : %{ &quot;channel&quot; =&gt; channel , &quot;paths&quot; =&gt; paths } } ) do build_zip ( paths ) await_zip ( channel ) end # ... end The function accepts an Oban Job with a channel name and a list of file paths, which it immediately passes on to the private build_zip/1 : defp build_zip ( paths ) do job_pid = self ( ) Task . async ( fn -&gt; zip_path = Zipper . new ( ) paths |&gt; Enum . with_index ( 1 ) |&gt; Enum . each ( fn { path , index } -&gt; :ok = Zipper . add_file ( zip_path , path ) send ( job_pid , { :progress , trunc ( index / length ( paths ) * 100 ) } ) end ) send ( job_pid , { :complete , zip_path } ) end ) end The function grabs the current pid, which belongs to the job, and kicks off an asynchronous task to handle the zipping. With a few calls to a fictional Zipper module the task works through each file path, adding it to the zip. After adding a file the task sends a :progress message with the percent complete back to the job. Finally, when the zip finishes, the task sends a :complete message with a path to the archive. The asynchronous call spawns a separate process and returns immediately. In order for the task to finish building the zip we need to wait on it. Typically we'd use Task.await/2 , but we'll use a custom receive loop to track the task's progress: defp await_zip ( channel ) do receive do { :progress , percent } -&gt; Endpoint . broadcast ( channel , &quot;zip:progress&quot; , percent ) await_zip ( channel ) { :complete , zip_path } -&gt; Endpoint . broadcast ( channel , &quot;zip:complete&quot; , zip_path ) after 30_000 -&gt; Endpoint . broadcast ( channel , &quot;zip:failed&quot; , &quot;zipping failed&quot; ) raise RuntimeError , &quot;no progress after 30s&quot; end end The receive loop blocks execution while it waits for :progress or :complete messages. When a message comes in it broadcasts to the provided channel and the client receives an update (this example uses Phoenix Channels , but any other PubSub type mechanism would work). As a safety mechanism we have an after clause that will timeout after 30 seconds of inactivity. If the receive block times out we notify the client and raise an error, failing the job.","ref":"reporting-progress.html#coordinating-processes","title":"Reporting Job Progress - Coordinating Processes","type":"extras"},{"doc":"Reporting progress asynchronously works in Oban because anything that blocks a worker's perform/1 function will keep the job executing. Jobs aren't executed inside of a transaction, which alleviates any limitations on how long a job can run. This technique is suitable for any single long running job where an end user is waiting on the results. You can read the &quot;Batching Jobs for Monitoring&quot; guide if you need to combine multiple jobs into a single output by creating batch jobs .","ref":"reporting-progress.html#made-possible-by-unlimited-execution","title":"Reporting Job Progress - Made Possible by Unlimited Execution","type":"extras"},{"doc":"Reporting job errors by sending notifications to an external service is essential to maintaining application health. While reporting is essential, noisy reports for flaky jobs can become a distraction that gets ignored. Sometimes we expect that a job will error a few times. That could be because the job relies on an external service that is flaky, because it is prone to race conditions, or because the world is a crazy place. Regardless of why a job fails, reporting every failure may be undesirable.","ref":"expected-failures.html","title":"Handling Expected Failures","type":"extras"},{"doc":"One solution for reducing noisy error notifications is to start reporting only after a job has failed several times. Oban uses Telemetry to make reporting errors and exceptions a simple matter of attaching a handler function. In this example we will extend Honeybadger reporting from the Oban.Telemetry documentation, but account for the number of processing attempts. To start, we'll define a Reportable protocol with a single reportable?/2 function: defprotocol MyApp.Reportable do @fallback_to_any true def reportable? ( worker , attempt ) end defimpl MyApp.Reportable , for : Any do def reportable? ( _worker , _attempt ) , do : true end The Reportable protocol has a default implementation which always returns true , meaning it reports all errors. Our application has a FlakyWorker that's known to fail a few times before succeeding. We don't want to see a report until after a job has failed three times, so we'll add an implementation of Reportable within the worker module: defmodule MyApp.Workers.FlakyWorker do use Oban.Worker defstruct [ ] defimpl MyApp.Reportable do @threshold 3 def reportable? ( _worker , attempt ) , do : attempt &gt; @threshold end @impl true def perform ( %{ args : %{ &quot;email&quot; =&gt; email } } ) do MyApp.ExternalService . deliver ( email ) end end Note that we've also used defstruct [] to make our worker a viable struct. This is necessary for our protocol to dispatch correctly, as protocols consider all modules to be a plain atom . The final step is to call reportable?/2 from our application's error reporter, passing in the worker module and the attempt number: defmodule MyApp.ErrorReporter do alias MyApp.Reportable def handle_event ( _ , _ , meta , _ ) do worker_struct = maybe_get_worker_struct ( meta . job . worker ) if Reportable . reportable? ( worker_struct , meta . job . attempt ) do context = Map . take ( meta . job , [ :id , :args , :queue , :worker ] ) Honeybadger . notify ( meta . reason , context , meta . stacktrace ) end end def maybe_get_worker_struct ( worker ) do try do { :ok , module } = Oban.Worker . from_string ( ) struct ( module ) rescue UndefinedFunctionError -&gt; worker end end end Attach the failure handler somewhere in your application.ex module: :telemetry . attach ( &quot;oban-errors&quot; , [ :oban , :job , :exception ] , &amp; ErrorReporter . handle_event / 4 , nil ) With the failure handler attached you will start getting error reports only after the third error . Giving Time to Recover If a service is especially flaky you may find that Oban's default backoff strategy is too fast. By defining a custom backoff function on the FlakyWorker we can set a linear delay before retries: # inside of MyApp.Workers.FlakyWorker @impl true def backoff ( % Job { attempt : attempt } ) do attempt * 60 end Now the first retry is scheduled 60s later, the second 120s later, and so on. Building Blocks Elixir's powerful primitives of behaviours, protocols and event handling make flexible error reporting seamless and extensible. While our Reportable protocol only considered the number of attempts, this same mechanism is suitable for filtering by any other meta value.","ref":"expected-failures.html#use-case-silencing-initial-notifications-for-flaky-services","title":"Handling Expected Failures - Use Case: Silencing Initial Notifications for Flaky Services","type":"extras"},{"doc":"Running every job queue on every node isn't always ideal. Imagine that your application has some CPU intensive jobs that you'd prefer not to run on nodes that serve web requests. Perhaps you start temporary nodes that are only meant to insert jobs but should never execute any. Fortunately, we can control this by configuring certain node types, or even single nodes, to run only a subset of queues .","ref":"splitting-queues.html","title":"Splitting Queues Between Nodes","type":"extras"},{"doc":"One notorious type of CPU intensive work is video processing. When our application is transcoding multiple videos simultaneously it is a major drain on system resources and may impact response times. To avoid this we can run dedicated worker nodes that don't serve any web requests and handle all of the transcoding. While it's possible to separate our system into web and worker apps within an umbrella, that wouldn't allow us to dynamically change queues at runtime. Let's look at an environment variable based method for dynamically configuring queues at runtime. Within config.exs our application is configured to run three queues: default , media and events : config :my_app , Oban , repo : MyApp.Repo , queues : [ default : 15 , media : 10 , events : 25 ] We will use an OBAN_QUEUES environment variable to override the queues at runtime. For illustration purposes the queue parsing all happens within the application module, but it would work equally well in releases.exs (or runtime.exs ). defmodule MyApp.Application do @moduledoc false use Application def start ( _type , _args ) do children = [ MyApp.Repo , MyApp.Endpoint , { Oban , oban_opts ( ) } ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end defp oban_opts do env_queues = System . get_env ( &quot;OBAN_QUEUES&quot; ) :my_app |&gt; Application . get_env ( Oban ) |&gt; Keyword . update ( :queues , [ ] , &amp; queues ( env_queues , &amp;1 ) ) end defp queues ( &quot;*&quot; , defaults ) , do : defaults defp queues ( nil , defaults ) , do : defaults defp queues ( _ , false ) , do : false defp queues ( values , _defaults ) when is_binary ( values ) do values |&gt; String . split ( &quot; &quot; , trim : true ) |&gt; Enum . map ( &amp; String . split ( &amp;1 , &quot;,&quot; , trim : true ) ) |&gt; Keyword . new ( fn [ queue , limit ] -&gt; { String . to_existing_atom ( queue ) , String . to_integer ( limit ) } end ) end end The queues function's first three clauses ensure that we can fall back to the queues specified in our configuration (or false , for testing). The fourth clause is much more involved, and that is where the environment parsing happens. It expects the OBAN_QUEUES value to be a string formatted as queue,limit pairs and separated by spaces. For example, to run only the default and media queues with a limit of 5 and 10 respectively, you would pass the string default,5 media,10 . Note that the parsing clause has a couple of safety mechanisms to ensure that only real queues are specified: It automatically trims while splitting values, so extra whitespace like won't break parsing (i.e. default,3 ) It only converts the queue string to an existing atom , hopefully preventing typos that would start a random queue (i.e. defalt ) Usage Examples In development (or when using mix rather than releases) we can specify the environment variable inline: OBAN_QUEUES=&quot;default,10 media,5&quot; mix phx.server # default: 10, media: 5 We can also explicitly opt in to running all of the configured queues: OBAN_QUEUES=&quot;*&quot; mix phx.server # default: 15, media: 10, events: 25 Finally, without OBAN_QUEUES set at all it will implicitly fall back to the configured queues: mix phx.server # default: 15, media: 10, events: 25","ref":"splitting-queues.html#use-case-isolating-video-processing-intensive-jobs","title":"Splitting Queues Between Nodes - Use Case: Isolating Video Processing Intensive Jobs","type":"extras"},{"doc":"This environment variable based solution is more flexible than running separate umbrella apps because we can reconfigure at any time. In a limited environment, like staging, we can run all the queues on a single node using the exact same code we use in production. In the future, if other workers start to utilize too much CPU or RAM we can shift them to the worker node without any code changes . This guide was prompted by an inquiry on the Oban issue tracker.","ref":"splitting-queues.html#flexible-across-all-environments","title":"Splitting Queues Between Nodes - Flexible Across all Environments","type":"extras"},{"doc":"Automated testing is an essential component of building reliable, long-lived applications. Oban orchestrates your application's background tasks, so naturally, testing Oban is highly recommended.","ref":"testing.html","title":"Introduction to Testing","type":"extras"},{"doc":"Ensure your app is configured for testing before you begin running tests. There are two testing modes available: :inline —jobs execute immediately within the calling process and without touching the database. This mode is simple and may not be suitable for apps with complex jobs. :manual —jobs are inserted into the database where they can be verified and executed when desired. This mode is more advanced and trades simplicity for flexibility. If you're just starting out, :inline mode is recommended: config :my_app , Oban , testing : :inline For more complex applications, or if you'd like complete control over when jobs run, then use :manual mode instead: config :my_app , Oban , testing : :manual Both testing modes prevent Oban from running any database queries in the background. This simultaneously prevents Sandbox errors from plugin queries and prevents queues from executing jobs unexpectedly. Changing Testing Modes Once the application starts in a particular testing mode it can't be changed. That's inconvenient if you're running in :inline mode and don't want a particular job to execute inline! Oban.Testing provides a helper to temporarily change testing modes within the context of a function. For example, to switch to :manual mode when Oban is configured for :inline testing: Oban.Testing . with_testing_mode ( :manual , fn -&gt; Oban . insert ( MyWorker . new ( %{ id : 123 } ) ) assert_enqueued worker : MyWorker , args : %{ id : 123 } end ) Or vice-versa, switch to :inline mode when the application is configured for :manual mode: Oban.Testing . with_testing_mode ( :inline , fn -&gt; { :ok , % Job { state : &quot;completed&quot; } } = Oban . insert ( MyWorker . new ( %{ id : 123 } ) ) end )","ref":"testing.html#setup-application-config","title":"Introduction to Testing - Setup Application Config","type":"extras"},{"doc":"Oban provides helpers to facilitate manual testing. These helpers handle the boilerplate of making assertions on which jobs are enqueued. The most convenient way to use the helpers is to use the module within your test case: defmodule MyApp.Case do use ExUnit.CaseTemplate using do quote do use Oban.Testing , repo : MyApp.Repo end end end Alternatively, you can use the testing module in individual tests if you'd prefer not to include helpers in every test. defmodule MyApp.WorkerTest do use MyApp.Case , async : true use Oban.Testing , repo : MyApp.Repo end Whichever way you choose, using use Oban.Testing requires the repo option because it's injected into many of the generated helpers. If you are using isolation with namespaces through PostgreSQL schemas (Ecto &quot;prefixes&quot;), you can also specify this prefix when using Oban.Testing : use Oban.Testing , repo : MyApp.Repo , prefix : &quot;private&quot; With Oban configured for testing and helpers in the appropriate places, you're ready for testing. Learn about unit testing with Testing Workers , integration testing with Testing Queues , or prepare for production with Testing Config .","ref":"testing.html#setup-testing-helpers","title":"Introduction to Testing - Setup Testing Helpers","type":"extras"},{"doc":"Worker modules are the primary &quot;unit&quot; of an Oban system. You can (and should) test a worker's callback functions locally, in-process, without touching the database. Most worker callback functions take a single argument: an Oban.Job struct. A job encapsulates arguments, metadata, and other options. Creating jobs, and verifying that they're built correctly, requires some boilerplate...that's where Oban.Testing.perform_job/3 comes in!","ref":"testing_workers.html","title":"Testing Workers","type":"extras"},{"doc":"The perform_job/3 helper reduces boilerplate when constructing jobs for unit tests and checks for common pitfalls. For example, it automatically converts args to string keys before calling perform/1 , ensuring that perform clauses aren't erroneously trying to match on atom keys. Let's work through test-driving a worker to demonstrate. Start by defining a test that creates a user and then use perform_job to manually call an account activation worker. In this context &quot;activation&quot; could mean sending an email, notifying administrators, or any number of business-critical functions—what's important is how we're testing it. defmodule MyApp.ActivationWorkerTest do use MyApp.Case , async : true test &quot;activating a new user&quot; do user = MyApp.User . create ( email : &quot;parker@example.com&quot; ) { :ok , _user } = perform_job ( MyApp.ActivationWorker , %{ id : user . id } ) end end Running the test at this point will raise an error that explains the module doesn't implement the Oban.Worker behaviour. 1) test activating a new account (MyApp.ActivationWorkerTest) Expected worker to be a module that implements the Oban.Worker behaviour, got: MyApp.ActivationWorker code: {:ok, user} = perform_job(MyApp.ActivationWorker, %{id: user.id}) To fix it, define a worker module with the appropriate signature and return value: defmodule MyApp.ActivationWorker do use Oban.Worker @impl Worker def perform ( % Job { args : %{ &quot;id&quot; =&gt; user_id } } ) do MyApp.Account . activate ( user_id ) end end The perform_job/3 helper's errors will guide you through implementing a complete worker with the following assertions: That the worker implements the Oban.Worker behaviour That args is encodable/decodable to JSON and always has string keys That the options provided build a valid job That the return value is expected, e.g. :ok , {:ok, value} , {:error, value} etc. That a custom new/1,2 callback works properly If all of the assertions pass, then you'll get the result of perform/1 for you to make additional assertions on.","ref":"testing_workers.html#testing-perform","title":"Testing Workers - Testing Perform","type":"extras"},{"doc":"You may wish to test less-frequently used worker callbacks such as backoff/1 and timeout/1 , but those callbacks don't have dedicated testing helpers. Never fear, it's adequate to build a job struct and test callbacks directly! Here's a sample test that asserts the backoff value is simply two-times the job's attempt : test &quot;calculating custom backoff as a multiple of job attempts&quot; do assert 2 == MyWorker . backoff ( % Oban.Job { attempt : 1 } ) assert 4 == MyWorker . backoff ( % Oban.Job { attempt : 2 } ) assert 6 == MyWorker . backoff ( % Oban.Job { attempt : 3 } ) end Similarly, here's a sample that verifies a timeout/1 callback always returns some number of milliseconds: test &quot;allowing a multiple of the attempt as job timeout&quot; do assert 1000 == MyWorker . timeout ( % Oban.Job { attempt : 1 } ) assert 2000 == MyWorker . timeout ( % Oban.Job { attempt : 2 } ) end Jobs are Ecto schemas, and therefore structs. There isn't anything magical about them! Explore the Oban.Job documentation to see all of the types and fields available for testing.","ref":"testing_workers.html#testing-other-callbacks","title":"Testing Workers - Testing Other Callbacks","type":"extras"},{"doc":"Where workers are the primary &quot;unit&quot; of an Oban system, queues are the &quot;integration&quot; point between the database and your application. That means to test queues and the jobs within them, your tests will have to interact with the database. To simplify that interaction, reduce boilerplate, and make assertions more expressive Oban.Testing provides a variety of helpers.","ref":"testing_queues.html","title":"Testing Queues","type":"extras"},{"doc":"During test runs you don't typically want to execute jobs. Rather, you need to verify that the job was enqueued properly. With the recommended test setup queues and plugins are disabled, and jobs won't execute at all. The Oban.Testing.assert_enqueued/2 and Oban.Testing.refute_enqueued/2 helpers simplify running queries to check for those available or scheduled jobs sitting in the database. Let's look at an example where we want to check that an activation job is enqueued after a user signs up: test &quot;scheduling activation upon sign up&quot; do { :ok , account } = MyApp.Account . sign_up ( email : &quot;parker@example.com&quot; ) assert_enqueued worker : MyApp.ActivationWorker , args : %{ id : account . id } , queue : :default end Likewise, we can also refute that a job was enqueued. The refute_enqueued helper takes the same arguments as assert_enqueued , though you should take care to be as unspecific as possible. Building on the example above, let's refute that a job is enqueued when account sign up fails: test &quot;bypassing activation when sign up fails&quot; do { :error , _reason } = MyApp.Account . sign_up ( email : &quot;parker@example.com&quot; ) refute_enqueued worker : MyApp.ActivationWorker end","ref":"testing_queues.html#asserting-enqueued-jobs","title":"Testing Queues - Asserting Enqueued Jobs","type":"extras"},{"doc":"Asserting and refuting about a single job isn't always enough. Sometimes you need to check for multiple jobs at once, or perform more complex assertions on the jobs themselves. In that situation, you can use all_enqueued instead. The first example we'll look at asserts that multiple jobs from the same worker are enqueued all at once: test &quot;enqueuing one job for each child record&quot; do :ok = MyApp.Account . notify_owners ( account ( ) ) assert jobs = all_enqueued ( worker : MyApp.NotificationWorker ) assert 3 == length ( jobs ) end The enqueued helpers all build dynamic queries to check for jobs within the database. Dynamic queries don't work for complex objects with nested values or a partial set of keys. In that case, you can use all_enqueued to pull jobs into your tests and use the full power of pattern matching for assertions. test &quot;enqueued jobs have args that match a particular pattern&quot; do :ok = MyApp.Account . notify_owners ( account ( ) ) for job &lt;- all_enqueued ( queue : :default ) do assert %{ &quot;email&quot; =&gt; _ , &quot;avatar&quot; =&gt; %{ &quot;url&quot; =&gt; _ } } = job . args end end","ref":"testing_queues.html#asserting-multiple-jobs","title":"Testing Queues - Asserting Multiple Jobs","type":"extras"},{"doc":"During integration tests it may be necessary to run jobs because they do work essential for the test to complete, i.e. sending an email, processing media, etc. You can execute all available jobs in a particular queue by calling Oban.drain_queue/1,2 directly from your tests. For example, to process all pending jobs in the &quot;mailer&quot; queue while testing some business logic: defmodule MyApp.BusinessTest do use MyApp.DataCase , async : true alias MyApp . { Business , Worker } test &quot;we stay in the business of doing business&quot; do :ok = Business . schedule_a_meeting ( %{ email : &quot;monty@brewster.com&quot; } ) assert %{ success : 1 , failure : 0 } = Oban . drain_queue ( queue : :mailer ) # Now, make an assertion about the email delivery end end See Oban.drain_queue/1,2 for a myriad of options and additional details.","ref":"testing_queues.html#integration-testing-queues","title":"Testing Queues - Integration Testing Queues","type":"extras"},{"doc":"An Oban instance's config is built from options passed to Oban.start_link during initialization and it determines the supervision tree that Oban builds. The instance config is encapsulated by an Oban.Config struct, which is then referenced by plugins, queues, and most public functions.","ref":"testing_config.html","title":"Testing Config","type":"extras"},{"doc":"Oban automatically normalizes and validates config options on initialization. That covers any static configuration, but it won't help when config is generated dynamically, at runtime. The Oban.Config.validate/1 helper is used internally when the config initializes. Along with each top level option, like the :engine or :repo , it recursively verifies all queue and plugin options. You can use validate/1 to verify dynamic configuration, e.g. options specified in runtime.exs : test &quot;production oban config is valid&quot; do config = &quot;config/config.exs&quot; |&gt; Config.Reader . read! ( env : :prod ) |&gt; get_in ( [ :my_app , Oban ] ) assert :ok = Oban.Config . validate ( config ) end When the configuration contains any invalid options, like an invalid engine, you'll see the test fail with an error like this: { :error , &quot;expected :engine to be an Oban.Queue.Engine, got: MyApp.Repo&quot; }","ref":"testing_config.html#testing-dynamic-config","title":"Testing Config - Testing Dynamic Config","type":"extras"},{"doc":"Validation is especially helpful for plugins that have complex configuration, e.g. Cron or the Dynamic* plugins from Oban Pro. As of Oban v2.12.0 all plugins implement the Oban.Plugin.validate/1 callback and we can test them in isolation as well as through the top level config. Suppose you have a helper function that returns a crontab config at runtime: defmodule MyApp.Oban do def cron_config do [ crontab : [ { &quot;0 24 * * *&quot; , MyApp.Worker } ] ] end end You can call that function within a test and then assert that it is valid with Oban.Plugin.validate/1 : test &quot;testing cron plugin configuration&quot; do config = MyApp.Oban . cron_config ( ) assert :ok = Oban.Plugins.Cron . validate ( config ) end Running this test will return an error tuple, showing that the cron expression isn't valid. { :error , % ArgumentError { message : &quot;expression field 24 is out of range 0..23&quot; } } Switch the expression from 0 24 * * * to 0 23 * * * , run the tests again, and everything passes!","ref":"testing_config.html#testing-dynamic-plugin-config","title":"Testing Config - Testing Dynamic Plugin Config","type":"extras"},{"doc":"This information is extracted and expanded from the CHANGELOG . This is a big release with a ton of new features and fixes, but also a few breaking changes. This guide will walk you through the upgrade process.","ref":"v2-0.html","title":"Upgrading to v2.0","type":"extras"},{"doc":"Update Oban to the latest version: defp deps do [ { :oban , &quot;~&gt; 2.0.0&quot; } ... ] end If you're an Oban Web+Pro user you'll also need to bump Oban.Web and add Oban.Pro: defp deps do [ { :oban , &quot;~&gt; 2.0.0&quot; } , { :oban_web , &quot;~&gt; 2.0.0&quot; , organization : &quot;oban&quot; } , { :oban_pro , &quot;~&gt; 0.3.0&quot; , organization : &quot;oban&quot; } ... ] end","ref":"v2-0.html#bump-your-deps","title":"Upgrading to v2.0 - Bump Your Deps","type":"extras"},{"doc":"The perform/2 callback is replaced with perform/1 , where the only argument is an Oban.Job struct. This unifies the interface for all Oban.Worker callbacks and helps to eliminate confusion around pattern matching on arguments. Change all worker definitions from accepting args and a job to only accept a job and match on the nested args key: - def perform(%{&quot;id&quot; =&gt; id}, _job) + def perform(%Job{args: %{&quot;id&quot; =&gt; id}}) For finer control of job backoff the backoff/1 callback now expects a job struct instead of an integer. Change any workers that expect an attempt number to match on the full job struct: - def backoff(attempt) + def backoff(%Job{attempt: attempt})","ref":"v2-0.html#oban-worker-changes","title":"Upgrading to v2.0 - Oban.Worker Changes","type":"extras"},{"doc":"The :verbose setting was renamed to :log to better align with values accepted by Ecto.Repo . config :my_app, Oban, - verbose: false, + log: false ... Pruning is now handled by the new plugin system. Replace :prune in your config and pass a :max_age value to the plugin: config :my_app, Oban, - prune: {:max_age, 60}, - prune_interval: 30_000, - prune_limit: 5000, + plugins: [{Oban.Plugins.Pruner, max_age: 60}] ... In test mode you can disable pruning by setting plugins to false instead: config :my_app, Oban, - prune: false, + plugins: false ... 🌟 Oban.Pro users may opt to use the DynamicPruner instead for finer control. For example, to set per-state retention periods: config :my_app , Oban , plugins : [ { Oban.Pro.Plugins.DynamicPruner , state_overrides : [ completed : { :max_age , { 1 , :day } } , discarded : { :max_age , { 1 , :month } } ] } ] ... Pulse tracking and orphaned job rescue are removed from base Oban. This change means that you will need to manually rescue any jobs left executing state after a crash or forced shutdown. Remove any :beats_maxage , :rescue_after or :rescue_interval settings from your config: config :my_app, Oban, - beats_maxage: 10, - rescue_after: 30_000, - rescue_interval: 5_000 ... 🌟 Oban.Pro users may use the Lifeline plugin to retain automatic orphaned job rescue with lightweight heartbeat recording: config :my_app , Oban , plugins : [ Oban.Pro.Plugins.Lifeline ] ...","ref":"v2-0.html#update-your-config","title":"Upgrading to v2.0 - Update Your Config","type":"extras"},{"doc":"The new perform_job test helper automates validating, normalizing and perform jobs in unit tests. To update your tests replace any calls to perform with the new helper: - assert :ok = MyApp.Worker.perform(%{id: 1}, %Oban.Job{}) + assert :ok = perform_job(MyApp.Worker, %{id: 1}) The perform_job helper will verify the worker, the arguments and any provided options. It will then verify that your worker returns a valid result and return the value for you to assert on. Within integration tests replace drain_queue/3 with drain_queue/2 : - Oban.drain_queue(:myqueue, with_safety: false) + Oban.drain_queue(queue: :myqueue, with_safety: false)","ref":"v2-0.html#update-your-tests","title":"Upgrading to v2.0 - Update Your Tests","type":"extras"},{"doc":"Telemetry event names have changed, along with some of the metadata and timing units. The new event names are consistent and align with the now-standard telemetry:span conventions. Update handlers to and match on the new event names: - def handle_event([:oban, :failure], measure, meta, _) do + def handle_event([:oban, :job, :exception], measure, meta, _) do And update the attach calls: - :telemetry.attach(&quot;oban&quot;, [[:oban, :failure]], &amp;handle_event/4, %{}) + :telemetry.attach(&quot;oban&quot;, [[:oban, :job, :exception]], &amp;handle_event/4, %{}) Finally, replace references to meta.stack with meta.stacktrace : - Sentry.capture_exception(meta.error, stacktrace: meta.stack, extra: extra) + Sentry.capture_exception(meta.error, stacktrace: meta.stacktrace, extra: extra) Here is a conversion chart for any other handlers you may have: [:oban, :started] -&gt; [:oban, :job, :start] [:oban, :success] -&gt; [:oban, :job, :stop] [:oban, :failure] -&gt; [:oban, :job, :exception] [:oban, :trip_circuit] -&gt; [:oban, :circuit, :trip] [:oban, :open_circuit] -&gt; [:oban, :circuit, :open]","ref":"v2-0.html#update-telemetry","title":"Upgrading to v2.0 - Update Telemetry","type":"extras"},{"doc":"Oban.Web is streamlined to share configuration with Oban and use the new plugin system. Remove any Oban.Web specific configuration: - config :my_app, Oban.Web, repo: MyApp.Repo Next, add the necessary plugins to the Oban config: config :my_app , Oban , plugins : [ Oban.Pro.Plugins.DynamicPruner , Oban.Pro.Plugins.Lifeline , Oban.Web.Plugins.Stats ] , ... Now remove ObanWeb from your application's supervision tree: children = [ MyApp.Repo, MyApp.Endpoint, {Oban, oban_opts}, - {ObanWeb, oban_web_opts} ] And delete any existing ObanWeb migrations: - defdelegate up, to: ObanWeb.Migrations - defdelegate down, to: ObanWeb.Migrations Finally, use the oban_dashboard macro to easily mount in your router: + import Oban.Web.Router scope &quot;/&quot; do pipe_through :browser - live &quot;/oban&quot;, ObanWeb.DashboardLive, layout: {ObanWeb.LayoutView, &quot;app.html&quot;} + oban_dashboard(&quot;/oban&quot;) end","ref":"v2-0.html#update-oban-web-optional","title":"Upgrading to v2.0 - Update Oban.Web (Optional)","type":"extras"},{"doc":"For Oban OSS users the v2.6 upgrade is a drop in replacement—there isn't anything to do! However, Web+Pro users will need to make some changes to unlock the goodness of engines.","ref":"v2-6.html","title":"Upgrading to v2.6","type":"extras"},{"doc":"Update Oban, Web, and Pro to the latest versions: [ { :oban , &quot;~&gt; 2.6&quot; } , { :oban_web , &quot;~&gt; 2.6&quot; , repo : &quot;oban&quot; } , { :oban_pro , &quot;~&gt; 0.7&quot; , repo : &quot;oban&quot; } ... ] Be sure to specify both :oban_web and :oban_pro if you use them both. There aren't any dependencies between Web and Pro now. That means you're free to use Pro for workers and only include Web for Phoenix servers, etc.","ref":"v2-6.html#bump-your-deps","title":"Upgrading to v2.6 - Bump Your Deps","type":"extras"},{"doc":"The SmartEngine uses centralized records to track and exchange state globally, enabling features such as global concurrency. First, create a migration to add the new oban_producers table: $ mix ecto.gen.migration add_oban_producers Within the migration module: use Ecto.Migration defdelegate change , to : Oban.Pro.Migrations.Producers If you have multiple Oban instances or use prefixes, you can specify the prefix and create multiple tables in one migration: use Ecto.Migration def change do Oban.Pro.Migrations.Producers . change ( ) Oban.Pro.Migrations.Producers . change ( prefix : &quot;special&quot; ) Oban.Pro.Migrations.Producers . change ( prefix : &quot;private&quot; ) end Next, update your config to use the SmartEngine : config :my_app , Oban , engine : Oban.Pro.Queue.SmartEngine , ... If you have multiple Oban instances you need to configure each one to use the SmartEngine , otherwise they'll default to the Basic engine.","ref":"v2-6.html#switch-to-the-smartengine","title":"Upgrading to v2.6 - Switch to the SmartEngine","type":"extras"},{"doc":"Oban Pro no longer writes heartbeat records to oban_beats . Instead, any Oban instance that runs queues must use the Gossip plugin to broadcast status via PubSub. To start, include the Gossip plugin in your Oban config: config :my_app , Oban , plugins : [ Oban.Plugins.Gossip ... With the default configuration the plugin will broadcast every 1 second. If that is too frequent you can configure the interval: plugins : [ { Oban.Plugins.Gossip , interval : :timer . seconds ( 5 ) } ...","ref":"v2-6.html#start-gossiping","title":"Upgrading to v2.6 - Start Gossiping","type":"extras"},{"doc":"Due to an improvement in how configuration is passed to workers the WorkflowManager plugin is no longer needed. You can remove it from your list of plugins: plugins: [ Oban.Pro.Plugins.Lifeline, - Oban.Pro.Plugins.WorkflowManager, ...","ref":"v2-6.html#remove-the-workflow-manager","title":"Upgrading to v2.6 - Remove the Workflow Manager","type":"extras"},{"doc":"The Lifeline plugin is simplified and doesn't accept as many configuration options. If you previously configured the record_interval or delete_interval you can remove them: plugins: [{ Oban.Pro.Plugins.Lifeline, - delete_interval: :timer.minutes(10), - record_interval: :timer.seconds(10), rescue_interval: :timer.minutes(5) }]","ref":"v2-6.html#remove-extra-lifeline-options","title":"Upgrading to v2.6 - Remove Extra Lifeline Options","type":"extras"},{"doc":"Once you've rolled out the switch to producer records, the smart engine and the gossip plugin you are free to remove the oban_beats table at your discretion (preferably in a follow up release, to prevent errors): $ mix ecto.gen.migration drop_oban_beats Within the generated migration module: use Ecto.Migration def up do drop_if_exists table ( &quot;oban_beats&quot; ) drop_if_exists table ( &quot;oban_beats&quot; , prefix : &quot;private&quot; ) # If you have any prefixes: end def down do # No going back! end","ref":"v2-6.html#drop-the-beats-table","title":"Upgrading to v2.6 - Drop the Beats Table","type":"extras"},{"doc":"This Oban release includes a required migration and a couple of optional, but recommended, changes.","ref":"v2-11.html","title":"Upgrading to v2.11","type":"extras"},{"doc":"Update Oban, Web, and Pro to the latest versions: [ { :oban , &quot;~&gt; 2.11&quot; } , { :oban_pro , &quot;~&gt; 0.10&quot; , repo : &quot;oban&quot; } , { :oban_web , &quot;~&gt; 2.9&quot; , repo : &quot;oban&quot; } ]","ref":"v2-11.html#bump-your-deps","title":"Upgrading to v2.11 - Bump Your Deps","type":"extras"},{"doc":"Oban's new leadership mechanism uses an unlogged table to track state globally. The v11 migration creates a new oban_peers table, and is required for leadership—without it many plugins won't run. To get started, create a migration to create the table: $ mix ecto.gen.migration create_oban_peers With in the generated migration module: use Ecto.Migration def up , do : Oban.Migrations . up ( version : 11 ) def down , do : Oban.Migrations . down ( version : 11 ) If you have multiple Oban instances or use an alternate prefix you'll need to run the migration for each prefix. The Oban.Peer module will safely handle a missing oban_peers table and log a warning.","ref":"v2-11.html#run-oban-migrations-for-v11","title":"Upgrading to v2.11 - Run Oban.Migrations for v11","type":"extras"},{"doc":"Now that we've pulled the PG notifier in from Oban Pro there are a few naming changes you should make. If your config explicitly declares Oban.PostgresNotifier , change it to the new namespaced version: Oban.Notifiers.Postgres : -notifier: Oban.PostgresNotifier +notifier: Oban.Notifiers.Postgres If you are using Pro's PG notifier, change it to the new namespaced version from Oban: -notifier: Oban.Pro.Notifiers.PG +notifier: Oban.Notifiers.PG","ref":"v2-11.html#update-notifier-names","title":"Upgrading to v2.11 - Update Notifier Names","type":"extras"},{"doc":"This release introduces centralized leadership through the Oban.Peer behaviour. To prevent duplicate plugin work across nodes, only one Oban instance within a cluster may be the leader. Unfortunately, if a node that doesn't run plugins becomes the leader then jobs may get stuck as available and plugins like Cron or Pruner won't run. The simplest solution is avoid plugins: false altogether: -plugins: false +plugins: [] See the Troubleshooting guide for more context.","ref":"v2-11.html#check-configuration-for-multi-node-setups","title":"Upgrading to v2.11 - Check Configuration for Multi-Node Setups","type":"extras"},{"doc":"Oban uses a single compound index for most queries. The index is comprised of job state , queue , priority , scheduled_at , and id . That single index is flexible enough to power most of Oban's queries. However, the column order is important, and the order created by Oban's migrations isn't optimal in all situations. If you're experiencing slow plugin queries, e.g. the Stager , then you may benefit from swapping the indexes. To do so, create a migration: $ mix ecto.gen.migration swap_primary_oban_indexes Within the generated migration module: @disable_ddl_transaction true @disable_migration_lock true def change do create_if_not_exists index ( :oban_jobs , [ :state , :queue , :priority , :scheduled_at , :id ] , concurrently : true , prefix : &quot;public&quot; ) drop_if_exists index ( :oban_jobs , [ :queue , :state , :priority , :scheduled_at , :id ] , concurrently : true , prefix : &quot;public&quot; ) end Be sure to reference the correct prefix if your oban_jobs table uses a prefix other than public .","ref":"v2-11.html#swap-the-compound-index-optional-but-recommended","title":"Upgrading to v2.11 - Swap the Compound Index (Optional, but Recommended)","type":"extras"},{"doc":"This Oban release includes a couple of optional configuration changes to aid in testing and development.","ref":"v2-12.html","title":"Upgrading to v2.12","type":"extras"},{"doc":"Update Oban (and optionally Pro) to the latest versions: [ { :oban , &quot;~&gt; 2.12&quot; } , { :oban_pro , &quot;~&gt; 0.11&quot; , repo : &quot;oban&quot; } ]","ref":"v2-12.html#bump-your-deps","title":"Upgrading to v2.12 - Bump Your Deps","type":"extras"},{"doc":"The new :testing option automates configuring an Oban instance for testing. Make the following change to your test.exs to opt into :manual testing mode: # test.exs - config :my_app, Oban, queues: false, plugins: false + config :my_app, Oban, testing: :manual If you'd prefer to run jobs inline as they're inserted, without involving the database, then you can use :inline mode instead: config :my_app , Oban , testing : :inline See the testing guide to learn more about test configuration.","ref":"v2-12.html#modify-configuration-for-testing","title":"Upgrading to v2.12 - Modify Configuration for Testing","type":"extras"},{"doc":"This Oban release includes a number of configuration changes and deprecations for redundant functionality.","ref":"v2-14.html","title":"Upgrading to v2.14","type":"extras"},{"doc":"Update Oban (and optionally Pro) to the latest versions: [ { :oban , &quot;~&gt; 2.14&quot; } , { :oban_pro , &quot;~&gt; 0.13&quot; , repo : &quot;oban&quot; } ]","ref":"v2-14.html#bump-your-deps","title":"Upgrading to v2.14 - Bump Your Deps","type":"extras"},{"doc":"The Repeater plugin is no longer necessary as the new Stager falls back to polling mode automatically. Remove the Repeater from your plugins: plugins: [ Oban.Plugins.Lifeline, Oban.Plugins.Pruner, - Oban.Plugins.Repeater The Stager is no longer a plugin because it's essential for queue operation. If you've overridden the staging interval: Reconsider whether that's necessary, staging is optimized to be a light-weight operation. If you're set on using a different interval, move it to :stage_interval plugins: [ Oban.Plugins.Lifeline, Oban.Plugins.Pruner, - {Oban.Plugins.Stager, interval: 5_000} ], + stage_interval: 5_000","ref":"v2-14.html#remove-repeater-and-stager-plugins","title":"Upgrading to v2.14 - Remove Repeater and Stager Plugins","type":"extras"},{"doc":"Now that Stager isn't a plugin, it isn't disabled by plugins: false . Be sure to use the :testing option introduced in v2.12 to automate configuration: # test.exs - config :my_app, Oban, queues: false, plugins: false + config :my_app, Oban, testing: :manual Without this change you may see a flurry of DBConnection.OwnershipError errors during test runs.","ref":"v2-14.html#ensure-configuration-for-testing","title":"Upgrading to v2.14 - Ensure Configuration for Testing","type":"extras"}]